/* found at: http://carlosrivero.com/stop-backspace-key-from-going-back-in-ie-and-firefox */
/* code to catch the backspace and stops the back default action */
if (typeof window.event == 'undefined'){
	document.onkeypress = function(e){
		var test_var=e.target.nodeName.toUpperCase();
		if (e.target.type) var test_type=e.target.type.toUpperCase();
		if ((test_var == 'INPUT' && test_type == 'TEXT') ||(test_var == 'INPUT' && test_type == 'PASSWORD')|| test_var == 'TEXTAREA'){
			return e.keyCode;
		}else if (e.keyCode == 8){
			e.preventDefault();
		}
	}
} else {
	document.onkeydown = function(){
		var test_var=event.srcElement.tagName.toUpperCase();
		if (event.srcElement.type) var test_type=event.srcElement.type.toUpperCase();
		if ((test_var == 'INPUT' && test_type == 'TEXT') ||(test_var == 'INPUT' && test_type == 'PASSWORD') || test_var == 'TEXTAREA'){
			return event.keyCode;
		}else if (event.keyCode == 8){
			event.returnValue=false;
		}
	}
}

var ratingTag;
var oldHistogram;
var numElements;
var badgeTooltip = null;
var quizBadge = null;

/* Set up event handlers for links on the page
   Not using inline JS as some of these have gotten more complicated with the unverified and not-logged-in cases */
function setupGamePageEventHandlers() {
	$j('#close-message').on('click', function(e) {
		$j('#game-message-box').fadeOut(100);
	});

	$j('#commentLink').on('click', function(e) {
		$j('#comments-section')[0].scrollIntoView();
		$j('#comments-section')[0].focus();
		showComments();
		e.preventDefault();
	});

	$j('#fav-button').on('click', function(e) {
        if(userID && userBlocked){
            var message = "Your account has been blocked from favoriting quizzes. Contact <a href='/feedback/'>customer support</a> to find out why.";
            showMainPageAlert(message, {type: 'danger'});
        } else if (userID && userVerified) {
			favoriteGame();
		} else if (userID && !userVerified) {
			window.SporcleLib.Modal.openUnverifiedModal({
				promoActionText : 'Favoriting quizzes'
			});
		} else {
			window.SporcleLib.Modal.openRegisterModal({
				analyticAction : "Favorite",
				regPath		   : "quiz_favorite",
				registerAction: function () {
					return function () {
						favoriteGame();
						window.location.reload();
					}
				}
			});
		}
	});

	$j('#ratingsBar').on('mouseover', function(e) {
		if (ratingTag) { ratingTag.removeClass('rated'); }
	});
	$j('#ratingsBar').on('mouseout', function(e) {
		if (ratingTag) { ratingTag.addClass('rated'); }
	});
	$j('.ratingLink').on('click', function(e) {
        if(userID && userBlocked){
            var message = "Your account has been blocked from rating quizzes. Contact <a href='/feedback/'>customer support</a> to find out why.";
            showMainPageAlert(message, {type: 'danger'});
        } else if (userID && userVerified) {
			var rating = parseInt(e.target.id.replace('rating',''));
			rateGame(rating);
		} else if (userID && !userVerified) {
			window.SporcleLib.Modal.openUnverifiedModal({
				promoActionText : 'Rating quizzes'
			});
		} else {
			window.SporcleLib.Modal.openRegisterModal({
				analyticAction : "Rate",
				regPath		   : "quiz_rate",
				registerAction : function() {
					return function () {
						rateGame(parseInt(e.target.id.replace('rating','')));
						window.location.reload();
					};
				}
			});
		}
	});

	$j('#send-user-message').on('click', function() {
		sendUserMessage(creatorHandle, $j('#send-user-message'));
	});

	$j('#reportLink').on('click', function(e) {
	    if(userID && userBlocked){
	        var message = "Your account has been blocked from reporting quizzes. Contact <a href='/feedback/'>customer support</a> to find out why.";
            showMainPageAlert(message, {type: 'danger'});
        } else if (userID && userVerified) {
			window.SporcleLib.Modal.openReportGameModal({
				form: gameActive ? 'published' : 'contributed'
			});
		} else if (userID && !userVerified) {
			window.SporcleLib.Modal.openUnverifiedModal({
				promoActionText : 'Reporting quizzes'
			});
		} else {
			window.SporcleLib.Modal.openRegisterModal({
				analyticAction : "Report",
				regPath		   : "quiz_report"
			});
		}
	});

	$j(document).on('closing', '[data-remodal-id=playlist-modal]', function(e) {
		$j('#playlist-filter').val('');
		$j('#playlist-matching-banner').hide();

		if ($j('.playlist-row').length) {
			$j('#create-playlist-tab').addClass('tab-off');
			$j('#create-playlist-tab').removeClass('tab-on');
			$j('#add-to-playlist-tab').addClass('tab-on');
			$j('#add-to-playlist-tab').removeClass('tab-off');
			$j('#create-playlist').hide();
			$j('#add-to-playlist').show();
		}
	});

	$j('#add-to-playlist-tab').on('click', function(event) {
		var tab = $j(event.target);

		if (tab.hasClass('tab-off')) {
			switchPlaylistAddTab(tab);
		}
	});

	$j('#create-playlist-tab').on('click', function(event) {
		var tab = $j(event.target);

		if (tab.hasClass('tab-off')) {
			switchPlaylistAddTab(tab);
		}
	});

	var playlistTimeout;
	$j('#playlist-filter').on('keyup', function(event) {
		clearTimeout(playlistTimeout);
		playlistTimeout = setTimeout(function() {
			filterPlaylists(event.target);
		},
		500);
	});

	$j('#create-button').on('click', function() {
		$j(this).prop('disabled', true)
		createPlaylist($j('#playlist-title').val(), encodedGameID);
	});

	$j('#editTagsLink').on('click', function() {
		if (userBlocked) {
			var message = "Your account has been blocked from editing quizzes. Contact <a href='/feedback/'>customer support</a> to find out why.";
			showMainPageAlert(message, {type: 'danger'});
		} else {
			window.SporcleLib.Modal.openEditTagsModal({
				gid : gameID,
				gameActive : window.gameActive ? window.gameActive : 0
			});
		}
	});

	$j('#copyGameLink').on('click', function(e) {
		if (userBlocked) {
			showMainPageAlert("Your account has been blocked from creating quizzes. <a href=\"/feedback/\">Contact customer support</a> to find out why.", {
				type:'danger',
				dismissible:true
			});
		} else if (userVerified) {
			copyGame(gameID);
		} else {
			window.SporcleLib.Modal.openUnverifiedModal({
				promoActionText : 'Copying quizzes'
			});
		}
	});

	var context = typeof(resultsPage) !== 'undefined' && resultsPage ? 'Results Page' : 'Game Page';

	$j('#share-game-challenge, #postgame-challenge-button').on('click', function(e) {
		e.preventDefault();

		var action = 'Challenge';
		if (e.target.id == "postgame-challenge-button" || $j(e.target).parent().attr('id') == "postgame-challenge-button") {
			action += ' Post-Play';
		}
		ga('send', 'event', context, action, window.gameurl_short);
		checkUserForChallenge(context);
	});

	$j('.fake-link').click(function(event) {
		event.preventDefault();
	});

	$j('#giveUp').on('click', function(event) {
		ga('send', 'event', 'Game Page', 'Give Up', window.gameurl_short);
	});

	$j('#share-game-embed').on('click', function(event) {
		ga('send', 'event', context, 'Embed Click', window.gameurl_short);
		SporcleLib.Modal.openEmbedGameModal({
			game_id : gameID
		});
	});

    $j('#send-quiz-message').on('click', function(event) {
        sendUserMessage(null, $j(this))
    });


	$j('#next-quiz-link').on('click', function(e) {
		ga('send', 'event', context, 'Next Quiz Button', window.gameurl_short);
	});

	// This is so tablets viewing the desktop site can open the timer settings menu
	$j('#timeBox, #scoreBox').on('touchstart', function() {});

	$j("#scoreBox .timerScoreControls .dropdown li button").on('click', function(e) {
		selectScoreSetting($j(e.currentTarget).attr('value'));

		//So dropdown closes
		$j(e.currentTarget).blur();
	});

	$j("#scoreBox .timerScoreControls .dropdown li button").on('keyup', function(e) {
		if (e.keycode == 13) {
			selectScoreSetting($j(e.currentTarget).attr('value'));
		}
	});

	$j("#timeBox .timerScoreControls .dropdown li button").on('click', function(e) {
		selectTimerSetting($j(e.currentTarget).attr('value'));

		//So dropdown closes
		$j(e.currentTarget).blur();
	});

	$j("#timeBox .timerScoreControls .dropdown li button").on('keyup', function(e) {
		if (e.keycode == 13) {
		selectTimerSetting($j(e.currentTarget).attr('value'));
		}
	});

	// Editor Pick Modal
	if (window.userID) {
		$j('#makeEditorPickLink').on('click', function() {
			window.SporcleLib.Modal.openPickModal({}, {
				pick_type	  : 'editor',
				game_id       : window.gameID,
				game_name     : window.gameNameDesc,
				category_id   : window.gameCategoryID,
				category_name : window.gameCategoryName
			});
		});
	}

	// Curator Pick Modal
	if (window.userID) {
		$j('.makeCuratorPickLink').on('click', function() {
			window.SporcleLib.Modal.openPickModal({}, {
				pick_type			   : 'curator',
				game_id            	   : window.gameID,
				game_name      	   	   : window.gameNameDesc,
				subcategory_id	 	   : this.dataset.subcat_id,
				game_subcategories 	   : window.gameSubcategories
			});
		});
	}

    $j("#game-message").on('click', '#decline-challenge-from-alert', function(){
    	var encodedId = $j(this).data('encoded-id');
        var ids = [encodedId]; //decline.php expects an array, even if there's just one id

        window.SporcleLib.Modal.openConfirmationModal({
            msg: "Are you sure you want to decline this challenge? This cannot be undone.",
            onYes: function (remodal) {
                $j.ajax({
                    url: '/challenge/ajax/decline.php',
                    type: 'post',
                    data: {ids:ids},
                    dataType: 'json'
                }).done(function(data) {
                    // Pop up success message.
                    if (data[encodedId]){
                        $j('#game-message').html("You have successfully declined this challenge.");
                        $j('#game-message-box').removeClass().addClass('alertGood').fadeIn(100);
                    } else {
                        $j('#game-message').html("Oops, something went wrong when declining this challenge. Please refresh and try again.");
                        $j('#game-message-box').removeClass().addClass('alertBad').fadeIn(100);
                    }
                }).fail(function(xhr) {
                    var message;
                    if (xhr.responseJSON.hasOwnProperty('message')) {
                        message = xhr.responseJSON.message;
                    } else {
                        message = "Oops, something went wrong when declining this challenge. Please refresh and try again.";
                    }
                    $j('#game-message').html(message);
                    $j('#game-message-box').removeClass().addClass('alertBad').fadeIn(100);
                });
                remodal.close();
            }
        });
    });
}

/* If we have a logged in user, open the challenge modal, otherwise give them a login prompt. */
function checkUserForChallenge(context) {
	if (userID && userVerified) {
		window.SporcleLib.Modal.openChallengeModal(null, {
			gid  : encodedGameID,
			sc   : numRight
		}, {
			done: function() {
				$j.post({
					url: '/games/ajax/check_for_challenge.php',
					data: {
						g: window.gameID
					},
					dataType: "json",
				}).done(function(response) {
					if (response && response.hasOwnProperty('has_open_challenge') && response.has_open_challenge === true) {
						// If you sent a challenge, you can't play in stopwatch mode. We don't currently check if this
						// actually means you have an open challenge.
						disableStopwatch();
						showOpenChallengeMessage({
							encoded_challenge_id : response.encoded_challenge_id,
							opponent_score       : parseInt(response.opponent_score, 10),
							opponent_time        : parseInt(response.opponent_time, 10),
							opponent_handle      : response.opponent_handle,
							opponent_deleted     : response.opponent_deleted,
							answer_count         : parseInt(response.answer_count, 10)
						});
					}
				})

			},
			fail: function(xhr) {
				$j('#challenge-send').show();
				$j('#challenge-ajax-loader').hide();

				var message;
				if (xhr.responseJSON.hasOwnProperty('message')) {
					message = xhr.responseJSON.message;
				} else {
					message = 'Oops, something went wrong when creating your challenge. Please refresh and try again';
				}

				showMainPageAlert(message, {
					type: 'danger',
					dismissible: true
				});
			}
		});
	} else if (userID && !userVerified) {
		window.SporcleLib.Modal.openUnverifiedModal({
			promoActionText : 'Challenging friends'
		});
	} else {
		window.SporcleLib.Modal.openRegisterModal({
			analyticAction : "Challenge - "+context,
			regPath		   : "quiz_challenge_user",
		});
	}
	return false;
}

/* Get the data we're going to need for the post game reckoning */
function buildGetReckoningDataRequest(gameID) {
	$j.ajax({
		url: '/games/ajax/get_data_for_reckoning.php',
		type: 'get',
		data: {g:gameID},
		dataType: 'json'
	}).done(function(response) {
		if (response) {
			averageScore = response.hasOwnProperty('averageScore') ? response.averageScore : 0;
			averageFriendScore = response.hasOwnProperty('averageFriendScore') ? response.averageFriendScore : null;
			if (typeof snark !== 'undefined') {
				snark.tiers = response.hasOwnProperty('snarkTiers') ? response.snarkTiers : [];
				snark.text = response.hasOwnProperty('snarkText') ? response.snarkText : {};
			}

			if (typeof reckoningQuestObjective !== 'undefined' && response.questObjective) {
				reckoningQuestObjective = response.questObjective;
			}

			if ($j('#avgPct').length && ($j('#avgPct').hasClass('result-score') || $j('#avgPct').prop('nodeName') == 'p')) {
				$j('#avgPct').html(Math.floor(averageScore * 100));

				$j('#gameOverMsg').show();
				$j('#reckonMsg').show();
				$j('#distribution-link').show();
			}

			if ($j('#avgFriendPct').length && $j('#avgFriendPct').hasClass('result-score')) {
				if (averageFriendScore) {
					$j('#avgFriendPct').html(Math.floor(averageFriendScore * 100));
				} else {
					$j('#friendAvg').children('.reckon-score').html('N/A');
				}
			}
			$j('#friendAvg').show();

			if ($j('.orange-score-promo').length) {
				$j('.orange-score-promo').on('click', function() {
					var context = typeof(resultsPage) !== 'undefined' && resultsPage ? 'Results Page' : 'Game Page';

					ga('send','event', context, 'Avg Friend Score Promo Button', window.gameurl_short);
					window.SporcleLib.Modal.openMemberOnlyModal({
						overridePromoText : 'Join Sporcle Orange to access your Friends\' Average Score',
						registrationPath  : 'avg_friend_score'
					});
				});
			}
		}

	}).fail(function(xhr) {
		// Don't do anything at this time.
	});
}

/* Handle changes to the follow button at the top of the page */
function updateFollowButton(data, followUserID, element) {
	if (data.success) {
		element.empty();
		element.prop('onclick',null).off('click');
		element.off('click mouseover mouseout');
		element.removeClass('following');

		if (data.followed) {
			element.html('Following');
			element.on('mouseover', function() {
				element.html('Unfollow');
			});
			element.on('mouseout', function() {
				element.html('Following');
			});
			element.on('click', function() {
				followUser(followUserID, true, element, function(data, followUserID, element) {
					updateFollowButton(data, followUserID, element);
				});
			});
			element.addClass('following');
		} else if (data.unfollowed) {
		    if(!data.isBlockedBy){
                element.on('click', function() {
                    followUser(followUserID, false, element, function(data, followUserID, element) {
                        updateFollowButton(data, followUserID, element);
                    });
                    ga('send', 'event', 'Follow Button', 'Click');
                });
                element.html('Follow');
            } else {
		        element.hide();
            }
		}
	} else {
		if (data.error) {
			showPageAlert(data.error, {'type': 'danger'});
		} else {
			showPageAlert('We encountered an error following this user. Please try again later or write into <a href="/feedback">feedback</a>.', {'type': 'danger'});
		}
	}
}

/* Get snark based on the percent correct */
function getSnark(userPct) {
	if (typeof snark === 'undefined' || !snark.hasOwnProperty('tiers') || !snark.hasOwnProperty('text')) {
		return '';
	}

	// First figure out the tier
	var tierID = null;
	var tiers = snark.tiers;
	for (var i = 0, len = tiers.length; i < len; i++) {
		if (tiers[i].min === tiers[i].max && userPct === tiers[i].min) {
			tierID = tiers[i].id;
			break;
		} else if (userPct >= tiers[i].min && userPct < tiers[i].max) {
			tierID = tiers[i].id;
			break;
		}
	}
	if (tierID === null) {
		return '';
	}

	// Then get the corresponding snark for that tier
	if (snark.text.hasOwnProperty(tierID)) {
		return window.SporcleLib.Sitdown.restoreAllowedTags(snark.text[tierID], true, true, []);
	} else {
		return '';
	}
}


/* Ratings */
function buildPopularInfoRequest(gameID) {

    var params = "g="+gameID;

    if (
        typeof window.sbData !== 'undefined' &&
        sbData.hasOwnProperty(4) &&
        typeof sbData[4]['check_against_baby_steps'] !== 'undefined' &&
        sbData[4]['check_against_baby_steps'] == 1
    ) {
        params += "&baby_steps_check=1"
    }

	return {
		ref: 'popular_info',
		url: '/games/ajax/get_popular_info.php',
		params: params,
		callback: function (data) {
			var info = parseAjaxQueueResponse(data);
			if (info) {
				showPopularInfo(info);
			}
		}
	};
}

function showPopularInfo(info) {
	// Update the data in the popular container above the game

    if (typeof info.favorite_count != 'undefined' && info.favorite_count >= 0) {
		var faveTooltipText = info.favorite_count == 1 ? formatNumber(info.favorite_count) + ' Favorite' : formatNumber(info.favorite_count) + ' Favorites';
        $j('#fav-icon').parent().attr('title', faveTooltipText);
	}

	$j('#playCount').html(info.play_count);
	$j('#commentNum').html(info.comments_count);
	if (info.user_favorited) {
		$j('#fav-icon')
            .addClass('favorited');
	}

	$j('#ratingsNum').html(info.ratings_count);
	if (info.user_rated) {
		$j('#ratingsMaskBg').addClass('rated');
		ratingTag = $j('#rating'+info.user_rating);
		ratingTag.addClass('rated');
	} else {
		var ratingWidth = Math.round(Math.floor(info.average_rating)*16 + (info.average_rating % 1)*12);
		$j('#ratingsMaskFg').width(ratingWidth);
	}
	$j('#avgRatingNum').html(info.average_rating);

	// Also update the comments section below the game
	$j('#comment-number').html(info.comments_count+ ' Comment'+(info.comments_count == 1 ? '' : 's'));
	$j('#showComments').html(info.comments_count == 0 ? 'Click to Comment' : 'Show Comment'+(info.comments_count == 1 ? '' : 's'));
	$j('#hideComments').html('Hide Comment'+(info.comments_count == 1 ? '' : 's'));
	if (info.comments_count > 0) {
		$j('#comment-warning').show();
	}
	$j('#showComments').on('click', showComments);
	$j('#hideComments').on('click', hideComments);
	$j('#comments-section').show();

	// Update the nominate link at the bottom
	if (info.user_nominated) {
		$j('#nominateLink')
			.html('Nominated')
			.off('click')
			.addClass('nominated');
	} else {
		$j('#nominateLink').on('click', function() {
			if (userID && userVerified) {
				nominateGame();
			} else if (userID && !userVerified) {
				window.SporcleLib.Modal.openUnverifiedModal({
					promoActionText : 'Nominating quizzes'
				});
			} else {
				window.SporcleLib.Modal.openRegisterModal({
					analyticAction : "Nominate",
					regPath		   : 'quiz_nominate',
					registerAction : function () {
						return function () {
							nominateGame();
							window.location.reload();
						}
					}
				});
			}
		});
	}

    $j('#addToPlaylistBtn').on('click', function() {
        if(userID && userBlocked){
            var message = "Your account has been blocked from editing playlists. Contact <a href='/feedback/'>customer support</a> to find out why.";
            showMainPageAlert(message, {type: 'danger'});
        } else if (userID && userVerified) {
            var playlistModal = $j('[data-remodal-id=playlist-modal]').remodal({hashTracking:false});
            getPlaylists(playlistModal, userVerified);
            $j('[data-remodal-id=playlist-modal]').css('position', 'absolute');
            $j('[data-remodal-id=playlist-modal]').css('top', '150px');

            $j('[data-remodal-id=playlist-modal]').css('max-width', '500px');
            var left = ($j(window).width()/2) - 250;
            $j('[data-remodal-id=playlist-modal]').css('left', left+'px');
        } else if (userID && !userVerified) {
            window.SporcleLib.Modal.openUnverifiedModal({
                promoActionText : 'Creating playlists'
            });
        } else {
            window.SporcleLib.Modal.openRegisterModal({
                analyticAction : "Add to Playlist",
				regPath		   : "quiz_add_to_playlist"
            });
        }
    });

    const bookmarkBtnEl = $j('#bookmark-btn');
	const bookmarkSrEl = $j('#bookmark-tooltip span.sr-only');
	const bookmarkTooltipEl = $j('#bookmark-tooltip div.accessible-tooltip');
	if (typeof(info.has_bookmarked) != 'undefined' && info.has_bookmarked) {
		bookmarkTooltipEl.text('Bookmarked')
		bookmarkSrEl.text('Bookmarked');
		$j('#bookmark-quiz').addClass('bookmarked');
	} else {
		bookmarkSrEl.text('Bookmarked');
		bookmarkTooltipEl.text('Bookmark this Quiz')
    }

    bookmarkBtnEl.on('click', bookmarkQuiz);

	if (typeof(info.can_edit) != 'undefined' && info.can_edit) {
		var editEl = $j('<span class="editGame tooltip'+(userVerified ? '' : ' unverified')+'" title="Edit Quiz"><a href="/create/edit/'+encodedGameID+'"></div></span>');
		if (userBlocked) {
			editEl.on('click', function(e) {
				e.preventDefault();
				var message = "Your account has been blocked from editing quizzes. Contact <a href='/feedback/'>customer support</a> to find out why.";
				showMainPageAlert(message, {type: 'danger'});
			});
		}

		$j('#popularBar').append(editEl);
	}

	if(typeof window.sbData !== 'undefined'){
	    if(typeof info.user_played_game !== 'undefined' && info.user_played_game == 0){
            //User hasn't played quiz yet and they're seeing the Baby Steps user bar action. Make sure we update the bar if user plays the game later
            window.sbData['update_baby_steps_on_play'] = 1;
        } else {
            window.sbData['update_baby_steps_on_play'] = 0;

        }
    }

	if (info.quiz_badge) {
		var template = _.template($j('#quiz-badge-template').html());
		info.quiz_badge.logged_in = info.user_logged_in;

		if ($j('#fixedHeight').length > 0) {
			$j('#fixedHeight').replaceWith($j(template(info.quiz_badge)));
		} else {
			$j('#alsoTry').replaceWith($j(template(info.quiz_badge)));
		}

		if (!info.user_logged_in) {
			$j('#badge-login').on('click', function() {
				ga('send','event', 'Quiz page', 'Join for Free');
				window.SporcleLib.Modal.openRegisterModal({
					analyticAction : 'Join for Free - Badge on quiz page',
					regPath		   : 'quiz_page_badge_prompt'
				});
			});
		}

		if ((!info.quiz_badge.badge_earned || info.quiz_badge.levelable) && info.user_logged_in) {
			quizBadge = info.quiz_badge;
            var conditionsTemp = _.template($j('#badge-conditions-template').html());
			var tooltipHtml = $j(conditionsTemp(quizBadge));
			var element = $j('#quiz-badge-art');

            badgeTooltip = new Opentip(element, tooltipHtml.html(), {
                stem                 : 'bottom left',
                stemLength           : 20,
                stemBase             : 30,
                fixed                : true,
                target               : element,
                targetJoint          : 'top right',
                tipJoint             : 'bottom left',
                hideTriggers         : ['tip', 'target'],
                hideOn               : 'mouseout',
                hideDelay            : 0.2,
                group                : 'badges',
                background           : 'white',
                borderColor          : '#dddddd',
                borderWidth          : 5,
                shadowOffset         : [10,10],
                shadowBlur           : 5,
                showEffect           : 'slide',
                showEffectDuration   : 0.1,
                removeElementsOnHide : true,
                hideEffectDuration   : 0.1,
				className			 : 'badge'
				}
			);
		}

	} else {
		$j('#alsoTry').show();
	}
}

function loggedOutBadgeBookmark() {
	ga('send','event', 'Quiz page', 'Join for Free');
	window.SporcleLib.Modal.openRegisterModal({
		analyticAction : 'Join for Free - Badge on quiz page',
		regPath		   : 'quiz_page_badge_bookmark_prompt'
	});
}

function clickBadgeBookmark(e){
	if (userBlocked) {
		var message = "Your account has been blocked from bookmarking badges. Contact <a href='/feedback/'>customer support</a> to find out why.";
		showMainPageAlert(message, {type: 'danger'});
	} else {
		$j.ajax({
			url: '/ajax/bookmark.php',
			type: 'post',
			data: {bookmark_badge_id: $j(e).attr('id')},
			success: function (data) {
				data = JSON.parse(data);
				if (data.bookmarked) {
					$j(e).addClass('bookmarked');
					quizBadge.is_bookmarked = true;
				} else if (data.unbookmarked) {
					$j(e).removeClass('bookmarked');
					quizBadge.is_bookmarked = false;
				}
				var conditionsTemp = _.template($j('#badge-conditions-template').html());
				var tooltipHtml = $j(conditionsTemp(quizBadge));

				badgeTooltip.content = tooltipHtml.html();
			},
			error: function (data) {
				data = JSON.parse(data.responseText);
				showPageAlert(data.error, {type: 'danger', dismissible: true});
			}
		});
	}
};

function buildHistogramRequest(gameID) {
	return {
		ref: 'histogram',
		url: '/games/ajax/histogram.php',
		params: "g="+gameID,
		callback: function (data) {
			data = parseAjaxQueueResponse(data);
            window.oldHistogram = data.old_histogram && data.old_histogram.length ? data.old_histogram : null;
            window.numElements = data.num_elements ? data.num_elements : null;
            if (data) {
				showHistogram(data, false);
			}
		}
	};
}

/**
 * Redraws histogram on game page
 * @param data
 * @param postGameplay
 */
function showHistogram(data, postGameplay) {
	var template = _.template($j('#histogram-template').html());
	if(postGameplay){
	    $j('#game-histogram, #quiz-stats #score-distribution .dividerText').remove();
    }
	$j('#quiz-stats #score-distribution').append($j(template(data)));
}

/**
 * Updates Score Distribution histogram immediately after gameplay.
 * Updating data here instead of relying on DB call to avoid race condition with logResults.php (writes to GameHistogramLive) and histogram.php (reads from GameHistogramLive).
 * @param numRight
 * @returns {string}
 */
function updateHistogramData(numRight) {

    //if oldHistogram is still false at this point, it means this is the quiz's first gameplay, so mock first row
    if(!oldHistogram){
        oldHistogram = [{
            num_right: numRight,
            countright: 1
        }];
    } else {

        //loop over oldHistogram to see which row numRight falls on, then increment that row's countright
        var rowExists = false;
        for (var i = 0; i < oldHistogram.length; i++){
            if(oldHistogram[i]['num_right'] == numRight){
                oldHistogram[i]['countright']++;
                rowExists = true;
                break;
            }
        }

        //No one has achieved this numRight yet, so mock first row
        if(!rowExists){
            oldHistogram.push({
                num_right: numRight,
                countright: 1
            });
        }
    }

    return oldHistogram;
}

/**
 * Fetches new histogram rows from histogram.php
 * @param histogram (histogram updated to reflect new gameplay)
 */
function fetchNewHistogram(histogram) {

    $j.post('/games/ajax/histogram.php', {g:gameID, histogram: histogram, num_elements: numElements, last_right: numRight})
        .done(function (res) {
            if(res && Object.keys(res).length){
                showHistogram(res, true);
            }
        });
}

function buildRatingDetailsRequest(gameID) {
	return {
		ref: 'rating_details',
		url: '/games/ajax/rating_details.php',
		params: "g="+gameID,
		callback: function (data) {
			data = parseAjaxQueueResponse(data);
			if (data) {
				showRatingDetails(data);
			}
		}
	};
}

function showRatingDetails(data) {
	var template = _.template($j('#rating-details-template').html());
	$j('#quiz-stats .rating-details').append($j(template(data)));

	if (data.display_as_popup) {
		$j('#ratingDetailsPopup .rating-details').append($j(template(data)));
		$j('#ratingDetailsPopupClose').on('click', function() {
			$j('#ratingDetailsPopup').hide();
		});
		$j('#avgRatingNum').addClass('highlight-on-hover').on('click', function() {
			$j('#ratingDetailsPopup').toggle();
		})
	}
}

function buildPlayedTagRequest(encodedGameID) {
	return {
		ref: 'played_tag',
		request_type: 'GET',
		url: '/ajax/played_quizzes.php',
		params: "games[]="+encodedGameID+"&scores=true",
		callback: function (data) {
			data = parseAjaxQueueResponse(data);
			if (data.played_games[encodedGameID]) {
				updatePlayedTag(data.played_games[encodedGameID]);
			}
		}
	};
}
function updatePlayedTag(playData) {
	var $played = $j('#played-tag');
	if ($played.length && playData.hasOwnProperty('total_score') && playData.hasOwnProperty('best_score')) {
		var userPct = 0;

		if (playData.total_score >= 1) {
			userPct = _.round(playData.best_score/playData.total_score, 2);

			if (userPct === 0 && playData.best_score > 0 ) {
				userPct = 0.01;
			} else if (userPct > 1) {
				userPct = 1;
			}
		}

		userPct = _.round(userPct*100, 0);

		window.bestPercent = userPct;

		$played
			.html('Best Score: '+playData.best_score+'/'+playData.total_score+' ('+userPct+'%)')
			.show();
	}
}

function buildPlaylistRequest(gameID, playlistID) {
	return {
		ref: 'playlist',
		url: '/games/ajax/playlist.php',
		params: "g="+gameID+"&p="+playlistID,
		callback: function (data) {
			if (_.has(data, 'result')) {
				var response = null;

				try {
					response = JSON.parse(data.result);
				} catch(e) {
					// Don't bother to do anything with failures
				}
				if (typeof response === 'object' && !$j.isEmptyObject(response)) {
					showPlaylist(response);
				}
			}
		}
	};
}

function showPlaylist(data) {
	var context = typeof(resultsPage) !== 'undefined' && resultsPage ? 'Results Page' : 'Game Page';

	if(typeof hasOrange !== 'undefined' && hasOrange) {
		var unplayedGames = data.games.filter(function(game) {
			return game.last_played == '';
		})
		var gamePool = unplayedGames.length > 0 ? unplayedGames : data.games;
		data.random_game = gamePool[Math.floor(Math.random() * unplayedGames.length)];
	}

	// Render the playlist container
	$j("#pl").html(_.template($j('#playlist-template').html())(data));

	data.results = typeof(resultsPage) !== 'undefined' && resultsPage ? 1: 0;
	$j('#pl-index').html(_.template($j('#playlist-index-template').html())(data));
	var $index = $j('#pl-index .playlist-dropdown');
	$j('#pl-index .button-playlist-menu, #pl-index .playlist-dropdown-header .icon.close').on('click', function(e) {
		if ($index.is(':visible')) {
			var action = 'Close';
		} else {
			var action = 'Open';
		}

		ga('send', 'event', context, action + ' Playlist Index (Integrated)', window.gameurl_short);

		$index.toggle();

		if (action == 'Open') {
			// scroll current game into view
			var $current = $j('#pl-index .playlist-dropdown-game-list .current');
			var $header = $j('#pl-index .playlist-dropdown-header');

			if ($current.length) {
				$j('#pl-index .playlist-dropdown-game-list')[0].scrollTop = $current[0].offsetTop - $header[0].offsetHeight;
			}

			$j('#pl-index .button-playlist-menu').addClass('active');
		} else {
			$j('#pl-index .button-playlist-menu').removeClass('active');
		}

		e.stopPropagation();
	});
	$j('#pl-index .playlist-dropdown-game-list a').on('click', function() {
		ga('send', 'event', context, 'Playlist Index Quiz (Integrated)', window.gameurl_short);
	});

	$index.on('click', function(e) {
		e.stopPropagation();
	});
	$j(document).on('click', function() {
		if ($index.is(':visible')) {
			$index.toggle();
			$j('#pl-index .button-playlist-menu').removeClass('active');
			ga('send', 'event', context, 'Close Playlist Index (Integrated)', window.gameurl_short);
		}
	});

	// Cache some jquery objects
	var $plContainer = $j('#pl-container');

	// Set up the "Likes" event handler
	$j('#pl-follow-button').on('click', function() {
        ga('send', 'event', context, 'Follow Playlist Button', window.gameurl_short);
        if(userID && userBlocked){
            var message = "Your account has been blocked from liking playlists. Contact <a href='/feedback/'>customer support</a> to find out why.";
            showMainPageAlert(message, {type: 'danger'});
        } else if (userID && userVerified) {
			likePlaylist(data.id);
		} else if (userID && !userVerified) {
			window.SporcleLib.Modal.openUnverifiedModal({
				promoActionText : 'Liking playlists'
			});
		} else {
			window.SporcleLib.Modal.openRegisterModal({
				analyticAction  : "Like Playlist",
				regPath		    : "quiz_follow_playlist",
				registerAction  : function () {
					return function () {
						likePlaylist(data.id);
						window.location.reload();
					};
				}
			});
		}
	});

	$j('#pl-random-button').on('click', function() {
		window.SporcleLib.Modal.openMemberOnlyModal({
			promoActionText  : 'Selecting a random playlist quiz',
            registrationPath : 'random_playlist_quiz_button_quiz_page'
		});
	})

	// Set up the "hover" event handlers
	$j('#pl-follow-button').on("mouseover", function() {
		$followButton = $j(this);
		if ($followButton.hasClass('following')) {
			$followButton.text("Unfollow");
		}
	});
	$j('#pl-follow-button').on("mouseout", function() {
		$followButton = $j(this);
		if ($followButton.hasClass('following')) {
			$followButton.text("Following");
		}
	});

	$plContainer.show();
	if (data.games.length > 3) {
		$j('#pl-container').slick({
			slidesToShow:3,
			slidesToScroll:1,
			initialSlide: data.current_index-1,
			prevArrow: "<div id='pl-prev'><div></div></div>",
			nextArrow: "<div id='pl-next'><div></div></div>",
		});
	} else {
		// Mimic slick display but disabled
		$j('#pl-container')
			.addClass('slick-initialized')
			.prepend($j("<div id='pl-prev' class='slick-arrow'><div></div></div>"))
			.append($j("<div id='pl-next' class='slick-arrow'><div></div></div>"));
		$j('.pl-game')
			.addClass('slick-slide')
			.css({
				'height':'100px',
				'width':'292px',
			});
		$j('.slick-arrow')
			.addClass('disabled');

		switch (data.games.length) {
			case 3:
				$j('.pl-game:nth-child(3)').css({'width':'293px'});
				break;

			case 2:
				$j('.pl-game').css({'width':'439px'});
				break;

			case 1:
				$j('.pl-game').css({'width':'879px'});
				break;

			default:break;
		}
	}

	$j('#pl-prev').on('click', function() {
		ga('send', 'event', context, 'Previous Quiz Playlist Button', window.gameurl_short);
	});
	$j('#pl-next').on('click', function() {
		ga('send', 'event', context, 'Next Quiz Playlist Button', window.gameurl_short);
	});
	$j('#pl-container .pl-game a').on('click', function(e) {
		var targetUrl = $j(e.target).attr('href').split(/[\/\?]/).slice(2,4).join('/');
		ga('send', 'event', context, 'Playlist Quiz', targetUrl);
	});
	$j('#pl-title .pl-name a').on('click', function(e) {
		ga('send','event', context, 'Playlist Title', data.url);
	})

	// Store this so we can use it for getReckoning
	window.playlist = data;
	if (window.resultsPage) {
		window.playlist.results = 1;
		if (!data.in_showdown) {
			playlistReckoning(0, false);
		}
	}
}

function playlistReckoning(userPct, updateBestScore) {
	if (typeof window.playlist === 'object' && window.playlist.hasOwnProperty('games')) {
		var nextIndex = window.playlist.current_index == window.playlist.game_count - 1 ? 0 : window.playlist.current_index + 1;
		var nextGame = window.playlist.games[nextIndex];

		// Update "best score" on current game if we beat it just now
		var curGame = _.find(window.playlist.games, function(g) { return g.id_old == window.encodedGameID; });
		if (curGame && (!curGame.best_score || curGame.best_score < userPct*100) && userPct != 0 && updateBestScore) {
			curGame.best_score = userPct*100;
		}

		$j('#next-quiz-link').attr('href', nextGame.url);
		$j('#next-quiz-link').attr('title', "Play next quiz: "+nextGame.name);

		if (!mweb) {
			if (userPct && updateBestScore) {
				var d = new Date()
				var months = ['January','February','March','April','May','June','July','August','September','October','November','December'];
				curGame.last_played = months[d.getMonth()] + " " + d.getDate() + ", " + d.getFullYear();
				$j('#playlistGame'+curGame.id+' .meta').html($j(
					'<span>Best Score: ' + Math.round(curGame.best_score * curGame.element_count / 100) + '/' + curGame.element_count + '</span>'
					// + '<span>Last Played: ' + curGame.last_played + '</span>'
				));
			}

			var context = typeof(resultsPage) !== 'undefined' && resultsPage ? 'Results Page' : 'Game Page';

			$j('#reckoning-playlist-container').html(_.template($j('#playlist-index-template').html())(window.playlist));
			var $index = $j('#reckoning-playlist-container .playlist-dropdown');
			$j('#reckoning-playlist-container .button-playlist-menu, #reckoning-playlist-container .playlist-dropdown-header .icon.close').on('click', function(e) {
				if ($index.is(':visible')) {
					var action = 'Close';
				} else {
					var action = 'Open';
				}

				ga('send', 'event', context, action + ' Playlist Index (Reckoning)', window.gameurl_short);

				$index.toggle();

				if (action == 'Open') {
					// scroll current game into view
					var $current = $j('#reckoning-playlist-container .playlist-dropdown-game-list .current');
					var $header = $j('#reckoning-playlist-container .playlist-dropdown-header');

					if ($current.length) {
						$j('#reckoning-playlist-container .playlist-dropdown-game-list')[0].scrollTop = $current[0].offsetTop - $header[0].offsetHeight;
					}
				}

				e.stopPropagation();
			});
			$j('#reckoning-playlist-container .playlist-dropdown-game-list a').on('click', function() {
				ga('send', 'event', context, 'Playlist Index Quiz (Reckoning)', window.gameurl_short);
			});
			$index.on('click', function(e) {
				e.stopPropagation();
			});
			$j(document).on('click', function() {
				if ($index.is(':visible')) {
					$index.toggle();
				}
			});

		}
		if (updateBestScore && userPct) {
			$j('.playlistDropdownGame'+curGame.id+' .bestScore').html(Math.round(curGame.best_score) + "%");
		}

	}
}

function likePlaylist(playlistID) {
	$j.ajax({
		url: '/games/ajax/like_playlist.php',
		type: 'post',
		data: {pl: playlistID},
		dataType: 'json'
	}).done(function(data) {
		if (_.has(data, 'likes') && _.has(data, 'is_liked')) {
			$j('#pl-likes-count').html(data.likes);
			if (data.is_liked) {
				$j('#pl-follow-button').addClass('following').text("Following");
			} else {
				$j('#pl-follow-button').removeClass('following').text("Follow");
			}
		}
	});
}

function switchPlaylistAddTab(tab) {
	$j('#add-to-playlist').toggle();
	$j('#create-playlist').toggle();

	if (tab.attr('id') == 'create-playlist-tab') {
		$j('#add-to-playlist-tab').removeClass('tab-on');
		$j('#add-to-playlist-tab').addClass('tab-off');
		$j('#create-playlist-tab').removeClass('tab-off');
		$j('#create-playlist-tab').addClass('tab-on');
	} else if (tab.attr('id') == 'add-to-playlist-tab') {
		$j('#add-to-playlist-tab').removeClass('tab-off');
		$j('#add-to-playlist-tab').addClass('tab-on');
		$j('#create-playlist-tab').removeClass('tab-on');
		$j('#create-playlist-tab').addClass('tab-off');
	}
}

function getPlaylists(playlistModal, userVerified) {
	if (userVerified) {
		$j.ajax({
			url: '/games/ajax/list_playlists.php',
			data: {g:encodedGameID},
			success: function(data) {
				if (data) {
					var info = data;
					formatTable(data.playlists);
					$j('#playlist-counter').html(data.playlist_count);
				} else {
					return;
				}
				playlistModal.open();
			}
		});
	} else {
		playlistModal.open();
	}
}

function formatTable(playlists) {
	if (Object.keys(playlists).length == 0) {
		$j('#no-playlists').remove();
		$j('#add-to-playlist-tab').hide();
		$j('#add-to-playlist').hide();
		$j('#create-playlist').show();
		$j('#create-playlist-tab').removeClass('tab-off');
		$j('#create-playlist-tab').addClass('tab-on');
	}

	var tableBody = $j('#playlist-table').find('tbody');
	tableBody.empty();
	var template = _.template($j('#add-to-playlist-template').html());
	$j.each(playlists, function(index, playlist) {
		tableBody.append(template(playlist));
	});

	if (Object.keys(playlists).length == 0) {
		$j('#no-playlists').remove();
		$j('#add-to-playlist-tab').hide();
		$j('#add-to-playlist').hide();
		$j('#create-playlist').show();
		$j('#create-playlist-tab').removeClass('tab-off');
		$j('#create-playlist-tab').addClass('tab-on');
	}
}

function addToPlaylist(target, gameID, playlistID) {
	$j.ajax({
		url: '/create/playlists/ajax/addgame.php',
		data: {g:gameID, p:playlistID},
		success: function(data) {
			if (data.success) {
				$j('#playlist-button-'+playlistID).removeClass('add-button');
				$j('#playlist-button-'+playlistID).addClass('added-button');
				$j('#playlist-button-'+playlistID).html('ADDED');

				$j('#playlist-button-'+playlistID).off('click');
				$j('#playlist-button-'+playlistID).removeAttr('onClick');
				$j('#playlist-button-'+playlistID).on('click', function() {
					removeFromPlaylist(target, gameID, playlistID);
				});
			} else {
				if (data.message) {
					$j('#playlist-error').html(data.message);
				} else {
					$j('#playlist-error').html("We're sorry! We encountered an error and couldn't process your request. If this persists, please <a href='/feedback/'>contact us</a> or let us know by <a href='/groups/reporting-problems'>reporting a problem</a>.");
				}
				$j('#playlist-error').slideDown(1000, function() {
					$j('#playlist-error').slideUp(1000);
				}).delay(3000);
			}
		}
	});
}

function removeFromPlaylist(target, gameID, playlistID) {
	$j.ajax({
		url: '/create/playlists/ajax/removegame.php',
		data: {g:gameID, p:playlistID},
		success: function(data) {
			if (data.success) {
				$j('#playlist-button-'+playlistID).removeClass('added-button');
				$j('#playlist-button-'+playlistID).addClass('add-button');
				$j('#playlist-button-'+playlistID).html('ADD to PLAYLIST');

				$j('#playlist-button-'+playlistID).off('click');
				$j('#playlist-button-'+playlistID).removeAttr('onClick');
				$j('#playlist-button-'+playlistID).on('click', function() {
					addToPlaylist(target, gameID, playlistID);
				});
			} else {
				if (data.message) {
					$j('#playlist-error').html(data.message);
				} else {
					$j('#playlist-error').html("We're sorry! We encountered an error and couldn't process your request. If this persists, please <a href='/feedback/'>contact us</a> or let us know by <a href='/groups/reporting-problems'>reporting a problem</a>.");
				}
				$j('#playlist-error').slideDown(1000, function() {
					$j('#playlist-error').slideUp(1000);
				}).delay(3000);
			}
		}
	});
}

function filterPlaylists(input) {
	var matchVal = $j(input).val();
	var matchVal = matchVal.toLowerCase();
	$j('.playlist-name').each(function(key, element) {
		if ($j(element).is('td')) {
			var filterVal = $j($j(element).children('a')[0]).html();
			var filterVal = filterVal.toLowerCase();
			if (filterVal.indexOf(matchVal) < 0) {
				$j($j(element).parent()).hide();
			} else {
				$j($j(element).parent()).show();
			}
		}
	});

	 if ($j("td.playlist-name:visible").length === 0) {
	 	$j('#playlist-matching-banner').show();
	 } else {
	 	$j('#playlist-matching-banner').hide();
	 }
}

function createPlaylist(name, gameID) {
	$j.ajax({
		url: '/create/playlists/ajax/createfromgamepage.php',
		data: {name:name, game:gameID},
		method: 'post',
		success: function(data) {
			if (data.success) {
				/* Update the create tab */
				$j('#title-container').remove();
				$j('#create-playlist').prepend('<div id="new-playlist-button"><div class="orange-lock" title="Private Playlist"></div><a href="'+data.playlist_url+'" id="go-to-playlist">GO to PLAYLIST</a></div>');
				$j('#create-playlist').prepend('<div id="new-playlist-info"><h5>New Playlist Created!</h5><a href="'+data.playlist_url+'" id="new-playlist-link">'+data.playlist_name+'</a></div>');
				$j('#create-playlist').prepend('<div id="playlist-icon"></div>');
				$j('#create-button').remove();
				$j('#playlist-count').remove();
				$j('#quiz-added-create-tab').remove();

				var playlistBody = $j('#playlist-table').find('tbody');
				var row = $j('<tr></tr>');
				row.append('<td class="playlist-name"><a href="'+data.playlist_url+'">'+data.playlist_name+'</a></td>');
				row.append('<td class="is-private"><div class="orange-lock" title="Private Playlist"></div></td>');
				row.append('<td class="add-to-playlist"><div class="added-button">ADDED</div></td>');

				playlistBody.prepend(row);

				$j('#playlist-table').show();
				$j('#no-playlists').remove();
			} else {
				if (data.message) {
					$j('#create-playlist-error').html(data.message);
				} else {
					$j('#create-playlist-error').html("We're sorry! We encountered an error and couldn't process your request. If this persists, please <a href='/feedback/'>contact us</a> or let us know by <a href='/groups/reporting-problems'>reporting a problem</a>.");
				}
				$j('#create-playlist-error').slideDown(1000, function() {
					$j('#create-playlist-error').slideUp(1000);
				}).delay(3000);

				$j('#create-button').prop('disabled', false)
			}
		}
	});


}

function rateGame(rateNum) {
	$j.ajax({
		url: '/games/ajax/rate.php',
		data: {r:rateNum, g:gameID},
		success: function(data) {
			if (data) {
				var info = data;
			} else {
				return;
			}
			$j('#ratingsNum').html(info.ratings_count_display);
			$j('#avgRatingNum').html(info.average_rating == '0.0' ? '0' : info.average_rating);
			if (info.user_rated) {
				$j('#ratingsMaskBg').addClass('rated');
				$j('.ratingLink').removeClass('rated');
				ratingTag = $j('#rating'+info.user_rating);
				ratingTag.addClass('rated');
				$j('#ratingsMaskFg').hide();
			} else {
				$j('.ratingLink').removeClass('rated');
				ratingTag = null;
				$j('#ratingsMaskFg').show();
				$j('#ratingsMaskFg').width(Math.floor(80*info.average_rating/5));
			}
		},
        error: function (data) {
            if(data.responseJSON && data.responseJSON.message){
                showMainPageAlert(data.responseJSON.message, {type: 'danger'});
            }
        }
	});
}
function bookmarkQuiz() {
    if (userID && userBlocked) {
        var message = "Your account has been blocked from bookmarking quizzes. Contact <a href='/feedback/'>customer support</a> to find out why.";
        showMainPageAlert(message, {type: 'danger'});
    } else if (userID){
		bookmarkCall(encodedGameID, null);
    } else {
        window.SporcleLib.Modal.openRegisterModal({
            analyticAction : "Add Bookmark",
			regPath		   : "quiz_bookmark",
			registerAction : function () {
				return function () {
					bookmarkCall(encodedGameID, function () {
						window.location.reload();
					});

				}
			}
        });
    }
}

function bookmarkCall(encodedGameID, callback) {
	$j.ajax({
		url: '/ajax/bookmark.php',
		type: 'post',
		data: {bookmark_game_id: encodedGameID},
		success: function(data) {
			const bookmarkSrEl = $j('#bookmark-tooltip span.sr-only');
			const bookmarkTooltipEl = $j('#bookmark-tooltip div.accessible-tooltip');

			data = JSON.parse(data);
			if (data.bookmarked) {
				$j('#bookmark-quiz').addClass('bookmarked');
				bookmarkSrEl.text('Bookmarked');
				bookmarkTooltipEl.text('Bookmarked');
			} else if (data.unbookmarked) {
				$j('#bookmark-quiz').removeClass('bookmarked');
				bookmarkSrEl.text('Bookmark this Quiz');
				bookmarkTooltipEl.text('Bookmark this Quiz');
			}

			if (callback) {
				callback();
			}
		},
		error: function(data) {
			data = JSON.parse(data.responseText);
			showPageAlert(data.error, {type:'danger', dismissible:true});
		}
	});
}
function favoriteGame() {
	$j.ajax({
		url: '/games/ajax/favorite.php',
		data: {g:gameID},
		success: function(data) {
			if (data) {
				var info = data;
			} else {
				return;
			}

            if (info.user_favorited) {
				$j('#fav-icon').addClass('favorited');
			} else {
				$j('#fav-icon').removeClass('favorited');
			}

			if (typeof info.favorite_count != 'undefined' && info.favorite_count >= 0) {
				var faveTooltipText = info.favorite_count == 1 ? formatNumber(info.favorite_count) + ' Favorite' : formatNumber(info.favorite_count) + ' Favorites';
				$j('#fav-icon').parent().attr('title', faveTooltipText);
			}
		},
        error: function (data) {
            if(data.responseJSON && data.responseJSON.message){
                showMainPageAlert(data.responseJSON.message, {type: 'danger'});
            }
        }
	});
}
function nominateGame() {
	$j.ajax({
		url: '/games/ajax/nominate.php',
		data: {g:gameID},
		success: function(data) {
			try {
				var info = JSON.parse(data);
			} catch(err) {
				return;
			}
			if (info.user_nominated) {
				$j('#nominateLink')
					.html('Nominated')
					.off('click')
					.addClass('nominated');
			}
		}
	});
}

/* Comments */
var commentsLoaded = false;
function getComments(gameid) {
	commentsView = new app.Views.GameCommentsView({
		gid: gameid,
		creatorHandle: (typeof creatorHandle !== 'undefined' && creatorHandle ? creatorHandle : '')
	});
	commentsLoaded = true;
}
function showComments() {
	$j('#commentBox').show();
	$j('#hideComments').show();
	$j('#showComments').hide();
	if (!commentsLoaded) {
		getComments(gameID);
	}
}
function hideComments() {
	$j('#commentBox').hide();
	$j('#hideComments').hide();
	$j('#showComments').show();
}
function disableShowComments() {
	hideComments();
	$j('#showComments')
		.addClass('disabled')
		.off('click')
		.on('click', function() {})
		.parent()
			.addClass('disabled');
}
function enableShowComments() {
	$j('#showComments')
		.removeClass('disabled')
		.on('click', showComments)
		.parent()
			.removeClass('disabled');
}

/* Tags */
function searchtag(searchbox)
{
	if ($j('#tagsearch').val().length >= 2) {
		updateSpan('/ajax/tagsearch.php', "ts="+encodeURIComponent($j('#tagsearch').val()), 'tagresults');
	} else {
		$j('#tagresults').html("No Results Found");
	}
}
function detag(whichtag)
{
	theTag = this;
	if (!theTag.id)	{
		theTag = whichtag;
	}

	var tagID = $j(theTag).attr('id');
	delete addedTags[tagID];

	if (theTag.className == "tagactive") {
		theTag.className = "tagdeactive";
	} else {
		theTag.className = "tagactive";
	}
}
var addedTags = {};
function addtag(whichtag)
{
	if (!(whichtag.id in addedTags)) {
		var newtagDiv = document.createElement("div");
		newtagDiv.id = whichtag.id;
		newtagDiv.className = "tagactive";
		newtagDiv.innerHTML = whichtag.innerHTML;
		newtagDiv.setAttribute('data-id', whichtag.getAttribute('data-id'));
		newtagDiv.setAttribute('data-subcat', whichtag.getAttribute('data-subcat'));
		newtagDiv.setAttribute('data-can-pick', whichtag.getAttribute('data-can-pick'));
		$j('#utag').append(newtagDiv);
		$j(newtagDiv).on('click', detag);
		addedTags[whichtag.id] = true;
	}
}
function savetags(gameActive)
{
	var savedtags = "";
	var tagsCount = 0;
	var subCatCount = 0;
	var displaytags = [];
	var months = ['Jan', 'Feb', 'Mar', 'Apr', 'May', 'Jun', 'Jul', 'Aug', 'Sep', 'Oct', 'Nov', 'Dec'];

	$j('.tagactive').each(function(i,e) {
		var tagID = e.getAttribute('data-id');
		var tagNameDisplay = e.innerHTML.trim();
		var tagNameSort = e.id.replace('TID_','').trim();
		var isSubcategory = parseInt(e.getAttribute('data-subcat'), 10) === 1;
		var canPick = parseInt(e.getAttribute('data-can-pick'), 10) === 1;
		var pickTimestamp = e.getAttribute('data-pick-date') ? parseInt(e.getAttribute('data-pick-date'), 10) : null;

		savedtags += e.id + ",";
		tagsCount++;
		if (isSubcategory) {
			subCatCount++;
		}

		if (isSubcategory) {
			// Make sure the gameSubcategories object is up to date
			if (window.gameSubcategories.hasOwnProperty(tagID)) {
				// This subcategory was already attached to the quiz when the page was loaded, update the properties
				// to reflect the most current information.
				window.gameSubcategories[tagID]['can_pick'] = canPick;
				window.gameSubcategories[tagID]['pick_date'] = pickTimestamp;

			} else {
				// This subcategory was added since the quiz page was loaded, either by this user or someone else, or
				// because it was changed to a subcategory.
				window.gameSubcategories[tagID] = {
					can_pick: canPick,
					pick_date: pickTimestamp,
					tag_name_display: tagNameDisplay,
					tag_name_sort: tagNameSort
				};
			}

			if (!gameActive && canPick) {
				var pickLink = '';

				if (window.gameSubcategories[tagID]['pick_date']){
					var pickDate = new Date(0);
					pickDate.setUTCSeconds(window.gameSubcategories[tagID]['pick_date']);
					var displayDate = months[pickDate.getMonth()] + ' ' + pickDate.getDate() + ' ' + pickDate.getFullYear();
					pickLink = " <a href='/curators/picks/'>("+(pickDate < new Date() ? "picked" : "scheduled")+" "+displayDate+")</a>";

				} else {
					pickLink = " <a class='makeCuratorPickLink' data-subcat_id="+tagID+" href='#'>(pick)</a>";
				}

				displaytags.push('<a href="/games/subcategory/'+tagNameSort+'">'+tagNameDisplay+' Quiz</a>'+pickLink);

			} else {
				displaytags.push('<a href="/games/subcategory/'+tagNameSort+'">'+tagNameDisplay+' Quiz</a>');
			}

		} else {
			// This is for regular tags that aren't subcategories.

			// Update the gameSubcategories object just in case this tag used to be a subcategory and no longer is.
			if (window.gameSubcategories.hasOwnProperty(tagID)) {
				delete window.gameSubcategories[tagID];
			}

			displaytags.push('<a href="/games/tags/'+tagNameSort+'">'+tagNameDisplay+'</a>');
		}
	});

	// Clear out any removed subcategories from the gameSubcategories object
	$j('.tagdeactive').each(function(i,e) {
		var tagID = e.getAttribute('data-id');
		if (window.gameSubcategories.hasOwnProperty(tagID)) {
			delete window.gameSubcategories[tagID];
		}
	});

	if (tagsCount > 12) {
		alert('Please limit your tags to a total of 12 before saving.');
		return;
	} else if (tagsCount < 3 && gameActive) {
		alert('Published quizzes need at least three tags.');
		return;
	} else if (subCatCount < 1 && gameActive) {
		alert('Published quizzes need at least one subcategory tag.');
		return
	}

	$j.post('/ajax/tagset.php', {g:gameID, gts:savedtags});
	$j('#tagList').html(displaytags.join(', '));
	// Curator Pick Modal
	if (window.userID) {
		$j('.makeCuratorPickLink').on('click', function() {
			window.SporcleLib.Modal.openPickModal({}, {
				pick_type			   : 'curator',
				game_id            	   : window.gameID,
				game_name      	   	   : window.gameNameDesc,
				subcategory_id	 	   : this.dataset.subcat_id,
				game_subcategories 	   : window.gameSubcategories
			});
		});
	}
}

/* Challenge Modal */
function requestCallback(response) {
	$j.get('/facebook/sporcle/fbrequest.php', {r:response.request, u:response.to.join(), g:gameID});
}

function buildCheckForChallengesRequest(gameID) {
	return {
		ref: 'check_for_challenge',
		url: '/games/ajax/check_for_challenge.php',
		params: "g="+gameID,
		callback: function (data) {
            var response = parseAjaxQueueResponse(data);
            if (response && response.hasOwnProperty('has_open_challenge') && response.has_open_challenge === true) {
				disableStopwatch();
				showOpenChallengeMessage({
					encoded_challenge_id : response.encoded_challenge_id,
					opponent_score       : parseInt(response.opponent_score, 10),
					opponent_time        : parseInt(response.opponent_time, 10),
					opponent_handle      : response.opponent_handle,
					opponent_deleted     : response.opponent_deleted,
					answer_count         : parseInt(response.answer_count, 10)
				});
			}
		}
	};
}

function showOpenChallengeMessage(challengeInfo) {
	if (window.app && app.config && app.config.components && app.config.components.hasOwnProperty('challenges') && app.config.components.challenges === 0) {
		$j('#game-message').html("You have an open challenge for this quiz; however, challenges are temporarily disabled. If you play the quiz now, it won't count toward your challenge. Please try again in a few minutes.");
		$j('#game-message-box').addClass('alertBad').fadeIn(250);

	} else {
		//challengeInfo.encoded_challenge_id will only be true if there is 1 challenge for this quiz, in which case we'll let the user decline the challenge from the alert bar. If there are many challenges for this user and quiz, the user must decline from his/her challenges page.
		if (challengeInfo.encoded_challenge_id) {
			if (!challengeInfo.opponent_score) {
				$j('#game-message').html('This quiz has an open challenge against <a href="/user/' + challengeInfo.opponent_handle + '">' + challengeInfo.opponent_handle + '</a>. Give it a play or <span id="decline-challenge-from-alert" data-encoded-id=' + challengeInfo.encoded_challenge_id + '>decline this challenge</span>.');
			} else {
				var score = Math.min(challengeInfo.opponent_score, challengeInfo.answer_count);
				var got100 = (score === challengeInfo.answer_count);
				var opponentHandle = challengeInfo.opponent_deleted ? challengeInfo.opponent_handle : '<a href="/user/' + challengeInfo.opponent_handle + '">' + challengeInfo.opponent_handle + '</a>';

				$j('#game-message').html('This quiz has an open challenge against '+opponentHandle+' who got ' + (score + '/' + challengeInfo.answer_count) + (challengeInfo.opponent_time && got100 ? ' in ' + formatTime(challengeInfo.opponent_time) : '')
					+ '. Give it a play or <span id="decline-challenge-from-alert" data-encoded-id=' + challengeInfo.encoded_challenge_id + '>decline this challenge</span>.');
			}
		} else {
			$j('#game-message').html('You have multiple open challenges for this quiz.  Go check out <a href="/challenge/">your challenges</a> to get the details.');
		}

		$j('#game-message-box').addClass('alertNeutral').fadeIn(250);
	}
}

function buildCheckForLeagueMatchRequest(gameID) {
	return {
		ref: 'check_for_league_match',
		url: '/games/ajax/check_for_league_match.php',
		params: 'g='+gameID,
		callback: function (data) {
			var response = parseAjaxQueueResponse(data);
			if (response && response.hasOwnProperty('active_league_match') && response.active_league_match === true && response.completed_match === false) {
				disableStopwatch();
				showLeagueMatchMessage(
					response.opponent_handle,
					response.end_time
				)
			} else if (response && response.hasOwnProperty('active_league_match') && response.active_league_match === true && response.completed_match === true) {
				disableStopwatch();
				showLeaguePlayedMessage(
					response.user_score,
        			response.answer_count,
        			response.encoded_tournament_id
				)
			}
		}
	}
}

function showLeagueMatchMessage(opponent, endTime) {
	$j('#game-message').html('Today\'s matchup is against <a href="/user/'+opponent+'">'+opponent+'</a>. Play by '+endTime+'.');
	$j('#game-message-box').addClass('alertNeutral').fadeIn(250);
}

function showLeaguePlayedMessage(user_score, answer_count, encoded_tournament_id) {
	$j('#game-message').html('You completed today\'s quiz with a score of ' +user_score+'/'+answer_count+'. You can see your tournament <a href="/leagues/tournament/'+encoded_tournament_id+'">here</a>.');
	$j('#game-message-box').addClass('alertGood').fadeIn(250);
}

function disableStopwatch() {
	// Disable switching the timer settings
	$j('#timeBox .timerScoreControls .dropdown li button').attr('disabled', true).off('click');
	stopwatch = false;
}

function enableStopwatchPick() {
	$j('#timeBox .timerScoreControls .dropdown li button').attr('disabled', false).on('click', function(e) {
		selectTimerSetting($j(e.currentTarget).attr('value'));
	});
}

function disableStopwatchPick() {
	$j('#timeBox .timerScoreControls .dropdown li button').attr('disabled', true).off('click');
}

/* Friend Results */
var friendScores = {
	params : {
		game : gameID,
		mode : 'highscores',
		all : false,
		new : true
	},
	cache : {}
};

function initialFriendScoresRequest(gameID) {
	// Show the stopwatch view on the results page if the last play was a stopwatch play
	if ((typeof resultsPage !== 'undefined') && resultsPage && (typeof lastPlayIsStopwatch !== 'undefined') && lastPlayIsStopwatch) {
		friendScores.params.mode = 'stopwatch';
	}

	updateFriendScores({}, function() {
		// Activate all the click handlers in the callback after the initial load is done
		$j('#friends-results-show-all').on('click', function() {
			showAllFriendScores();
		});

		$j('#friends-results-hide-all').on('click', function() {
			showCollapsedFriendScores();
		});

		$j('#friends-results-highscores').on('click', function() {
			if (friendScores.params.mode !== 'highscores') {
				showCollapsedFriendScores({mode: 'highscores'});
			}
		});

		$j('#friends-results-showdown').on('click', function() {
			if (friendScores.params.mode !== 'showdown') {
				showCollapsedFriendScores({mode: 'showdown'});
			}
		});

		$j('#friends-results-stopwatch').on('click', function() {
			if (friendScores.params.mode !== 'stopwatch') {
				showCollapsedFriendScores({mode: 'stopwatch'});
			}
		});
	});
}

function showAllFriendScores(additionalParams) {
	var params = {all:true};
	if (typeof additionalParams !== 'undefined') {
		params = _.extend(params, additionalParams);
	}
	updateFriendScores(params);
}

function showCollapsedFriendScores(additionalParams) {
	if ($j('#friends-results-wrapper').length === 0) {
		// User is not logged in, there's no friends score table on the page
		return;
	}
	var params = {all:false};
	if (typeof additionalParams !== 'undefined') {
		params = _.extend(params, additionalParams);
	}
	updateFriendScores(params, function() {
		var friendsTop = $j("#friends-results-title").offset().top;
		if (friendsTop < window.pageYOffset) {
			window.scrollTo(0, friendsTop);
		}
	});
}

function updateFriendScores(additionalParams, callback) {
	friendScores.params = _.extend(friendScores.params, additionalParams);

	var $navItem = $j('#friends-results-'+friendScores.params.mode);
	if (!$navItem.hasClass('active')) {
		$j('#friends-results-nav .nav-item').removeClass('active');
		$navItem.addClass('active');
	}

    var $container = $j('#friends-results-table');
	if (friendScores.cache.hasOwnProperty(friendScores.params.mode)) {
		// We already have cached data, no need to make the ajax call
		displayFriendScores(
			friendScores.cache[friendScores.params.mode],
			friendScores.params.mode,
			friendScores.params.all
		);

		if (typeof callback === 'function') {
			callback();
		}

	} else {
		$navItem.addClass('loading');

		$j.ajax({
			url    : '/games/ajax/friends_scores.php',
			method : 'post',
			data   : friendScores.params
		}).always(function() {
			$navItem.removeClass('loading');

		}).done(function(data) {
			sortAndRankFriendScores(data, friendScores.params.mode);
			friendScores.cache[friendScores.params.mode] = data;

			displayFriendScores(
				friendScores.cache[friendScores.params.mode],
				friendScores.params.mode,
				friendScores.params.all
			);

			if (typeof callback === 'function') {
				callback();
			}

		}).fail(function(jqXHR, textStatus, errorThrown) {
			if (jqXHR.readyState == 4) {
				// Request has completely returned (i.e. not interrupted)
				$j('#friends-results-table').html('<div class="alertBad" style="margin:0 20px">There was an error loading the data.</div>');
			}
		});
	}
}

/**
 * Renders a results/scores table such as the Friends Results or Showdown Top Performers
 *
 * @param {object} $container - jQuery object referencing the DOM element where we want to put the table data
 * @param {object[]} scores - array of scores that we want to render in the table
 * @param {number} numAnswers - number of answers, needed for the best score header label
 * @param {string} mode - what type of scores we're displaying: highscores, stopwatch, or showdown
 * @param {object} user - user metadata, only passed in if we want to display an "unplayed" row in the table
 */
function displayScoresTable($container, scores, numAnswers, mode, user) {

	$container.empty();

	// Determine which templates to use
	var tableTemplate, rowTemplate;
	if (mode === 'highscores' || mode === 'stopwatch') {
		tableTemplate = $j('#highscores-results-template').html();
		rowTemplate = $j('#highscores-results-row-template').html();
	} else {
		tableTemplate = $j('#showdown-results-template').html();
		rowTemplate = $j('#showdown-results-row-template').html();
	}

	// Append table to element
	var $div = $j('<div>').html(_.template(tableTemplate)({num_answers: numAnswers}));

	// Append rows to the table
	for (var i = 0, len = scores.length; i < len; i++) {
		$div.find('#standings-body').append(_.template(rowTemplate)({row: scores[i]}));
	}

	var sporcleBot = false;
	_(scores).each(function(score) {
		if (score.user_id == 219890) {
			sporcleBot = true;
		}
	});

	if (scores.length >= 250) {
		$div.find('#standings-body').append($j('<tr><td></td><td class="limit-notice" colspan="5">Friends\' Results display your top 250 friend scores</td></tr>'));
	}

	// Add "unplayed" row if user data was supplied
	if (typeof user === 'object') {
		var unplayedRowTemplate = $j('#unplayed-results-row-template').html();
		$div.find('#standings-body').prepend(_.template(unplayedRowTemplate)({mode: mode, user: user}));
	}

	$container.html($div);
}

/**
 * Display the "Friends Results" data.  Figures out which score records to display and if we're displaying an unplayed
 * row before passing the data to the displayScoresTable function.
 *
 * @param {object} data - the friends scores data either from the cached data or the results of the ajax call
 * @param {string} mode - what type of friends scores to display: highscores, stopwatch, or showdown
 * @param {boolean} showAll - flag indicating if we want to display all the scores, or the collapsed version
 */
function displayFriendScores(data, mode, showAll) {

	// Reset the show/hide buttons
	$j('#friends-results-hide-all, #friends-results-show-all').hide();

	var collapsedCount = 5;
	var user;

	// Figure out which scores records to display
	var scoresToDisplay = [];
	if (showAll) {
		scoresToDisplay = data.scores;
		if (!data.hasOwnProperty('user_index') && data.hasOwnProperty('user')) {
			// User has not played the quiz, make sure to show the "unplayed" line
			user = data.user;
		}
	} else {
		if (data.hasOwnProperty('user_index')) {
			// User has played the quiz
			if (data.user_index > collapsedCount - 1) {
				// Make sure their data is shown
				scoresToDisplay = data.scores.slice(0, collapsedCount - 1);
				scoresToDisplay.push(data.scores[data.user_index]);
			} else {
				// No need to do anything special
				scoresToDisplay = data.scores.slice(0, collapsedCount);
			}
		} else {
			// User has not played the quiz, make room for the "unplayed" line
			scoresToDisplay = data.scores.slice(0, collapsedCount - 1);
			user = data.user;
		}
	}

	// Update the scores table
	displayScoresTable($j('#friends-results-table'), scoresToDisplay, data.num_answers, mode, user);

	// Update the count of scores
	var totalCount = data.scores.length;
	var displayCount = scoresToDisplay.length;

	$j('#friends-results-count').html(totalCount);

	// Update the state of the show/hide buttons
	if (showAll && totalCount > collapsedCount) {
		$j('#friends-results-hide-all').show();
	} else if (totalCount > displayCount) {
		$j('#friends-results-show-all').show();
	}
}

/**
 * Given an object with scores data, sorts and ranks the data based on the rules for each mode.  High Scores and
 * Stopwatch are ranked by best score, best time, and user_id.  Showdown is ranked by rating, win count, and user_id.
 * Also figures out the index in the array of the current user, if they have any data.
 *
 * @param {object} data - the object containing the scores data, and where we'll update the user_index
 * @param {string} mode - what type of friends scores to display: highscores, stopwatch, or showdown
 */
function sortAndRankFriendScores(data, mode) {
	var comparator;
	if (mode === 'highscores' || mode === 'stopwatch') {
		// regular or stopwatch
		comparator = function(a, b) {
			// b first does desc, a first does asc
			return b.best_score_num - a.best_score_num || a.best_time - b.best_time || a.user_id - b.user_id;
		};
	} else {
		// showdown
		comparator = function(a, b) {
			// b first does desc, a first does asc
			return b.rating - a.rating || b.win_count - a.win_count || a.user_id - b.user_id;
		};
	}

	data.scores.sort(comparator);

	rankSortedArrayOfObjects(data.scores, ['best_score_num', 'best_time']);

	for (var i = 0, len = data.scores.length; i < len; i++) {
		if (window.userID === data.scores[i].user_id) {
			data.user_index = i;
		}
	}
}

/**
 * Determine if two objects have the same values for a set of properties
 *
 * @param {object} obj1 - First object to compare
 * @param {object} obj2 - Seconds object to compare
 * @param {string[]} properties - array of property names that we want to compare
 * @returns {boolean}
 */
function objectsHaveMatchingValues(obj1, obj2, properties) {
	for (var i = 0, len = properties.length; i < len; i++) {
		var prop = properties[i];
		if (!obj1.hasOwnProperty(prop) || !obj2.hasOwnProperty(prop) || obj1[prop] !== obj2[prop]) {
			return false;
		}
	}

	return true;
}

/**
 * Rank a sorted array of objects based on comparing the properties passed in via the properties array
 *
 * @param {object[]} array - sorted array of objects that we want to assign ranks to
 * @param {string[]} properties - array of property names that we want to compare
 */
function rankSortedArrayOfObjects(array, properties) {
	var rank = 0;
	var rankCount = 0;
	var previousValues = {};

	array.forEach(function(currentValues){
		if (rank === 0) {
			// First element in the array is always ranked 1
			rank = 1;
			rankCount = 1;

		} else if (objectsHaveMatchingValues(currentValues, previousValues, properties)) {
			// All properties have matching values, rank doesn't change but the count of scores with this rank changes.
			rankCount++;

		} else {
			// New values, so increment the rank and reset the rank count.
			rank += rankCount;
			rankCount = 1;
		}

		currentValues.rank = rank;
		previousValues = currentValues;
	});
}

//Redefined from main.js, so mobile web has access
function formatTime(time) {
	time = Math.round(time);
	var hours = String("00" + (Math.floor(time / 3600))).slice(-2);
	var minutes = String("00" + (Math.floor(time / 60) % 60)).slice(-2);
	var seconds = String("00" + (time % 60)).slice(-2);

	if (hours != '00') {
		return hours+":"+minutes+":"+seconds;
	} else {
		return minutes+":"+seconds;
	}
}

/**
 *
 * @param {string} mode
 * @param {number} score
 * @param {number} time
 */
function addPlayToFriendScoresCache(mode, score, time) {
	var userFound = false;
	var numAnswers = window.answers.length;
	var cache = friendScores.cache[mode];

	for (var i = 0, len = cache.scores.length; i < len; i++) {
		// Update the user's element in the scores array.
		var element = cache.scores[i];
		if (window.userID === element.user_id) {
			userFound = true;

			element.play_count++;
			element.play_date = window.loadTimeString;

			if (score > element.best_score_num) {
				element.best_score_num = score;
				element.best_score = numAnswers ? score/numAnswers : 0;
			}

			if (score === numAnswers && (element.best_time === null || element.best_time > time)) {
				element.best_time = time;
				element.best_time_string = formatTime(time);
			}
		}
	}

	if (!userFound) {
		// Add an element to the scores array
		cache.scores.push({
			best_score : numAnswers ? score/numAnswers : 0,
			best_score_num : score,
			best_time : score === numAnswers ? time : null,
			best_time_string : score === numAnswers ? formatTime(time) : "",
			handle : cache.user.handle,
			image : cache.user.image,
			is_current_user : true,
			play_count : 1,
			play_date : window.loadTimeString,
			rank : 0,
			role : cache.user.role,
			user_id : window.userID
		});
	}

	sortAndRankFriendScores(cache, mode);

	return cache;
}

/**
 *
 * @param {object} plays
 */
function addShowdownPlaysToFriendScoresCache(plays, botMatch) {
	var mode = 'showdown';
	var numAnswers = window.answers.length;
	var cache = friendScores.cache[mode];
	var play;

	var RESULT_WIN = 2;
	var RESULT_LOSS = 0;
	var RESULT_TIE = 1;

	for (var i = 0, len = cache.scores.length; i < len; i++) {
		// Update the user's element in the scores array.
		var element = cache.scores[i];
		if (plays.hasOwnProperty(element.user_id)) {
			play = plays[element.user_id];

			if (play.result === RESULT_WIN) {
				element.win_count++;
			} else if (play.result === RESULT_LOSS) {
				element.loss_count++;
			} else if (play.result === RESULT_TIE) {
				element.tie_count++;
			}

			element.play_date = window.loadTimeString;

			if (play.score > element.best_score_num) {
				element.best_score_num = play.score;
				element.best_score = numAnswers ? play.score/numAnswers : 0;
			}

			if (play.score === numAnswers && (element.best_time === null || element.best_time >  play.time)) {
				element.best_time =  play.time;
				element.best_time_string = formatTime( play.time);
			}

			if (botMatch && !element.rating) {
				element.rating = '-';
			} else {
				element.rating = play.rating ? play.rating : '-';
			}

			delete plays[element.user_id];

			if (Object.keys(plays).length === 0) {
				console.log('all plays updated in cache');
				break;
			}
		}
	}

	// For any plays that didn't match an element in the array, add it if it belongs to the user or one of their friends
	for (var playerID in plays) {
		playerID = parseInt(playerID, 10);
		if (playerID === window.userID || cache.friends.includes(playerID)) {
			play = plays[playerID];

			cache.scores.push({
				best_score : numAnswers ? play.score/numAnswers : 0,
				best_score_num : play.score,
				best_time : play.score === numAnswers ? play.time : null,
				best_time_string : play.score === numAnswers ? formatTime(play.time) : "",
				handle : play.handle,
				image : play.image,
				is_current_user : playerID === window.userID,
				win_count : play.result === RESULT_WIN ? 1 : 0,
				loss_count : play.result === RESULT_LOSS ? 1 : 0,
				tie_count : play.result === RESULT_TIE ? 1 : 0,
				play_date : window.loadTimeString,
				rank : 0,
				rating : play.rating,
				role : play.role,
				user_id : userID
			});
		}
	}

	sortAndRankFriendScores(cache, mode);
}

/**
 * Get the showdown top performers data, calculate the ranks, and display the data
 * @param gameID
 */
function displayShowdownTopPerformers(gameID) {
	$j.ajax({
		url: '/games/ajax/showdown_top_performers.php',
		type: 'get',
		data: {g:gameID},
		dataType: 'json'
	}).done(function(data) {

		if (Array.isArray(data) && data.length) {
			rankSortedArrayOfObjects(data, ['rating']);
			displayScoresTable($j('#top-performers-wrapper'), data, data[0].num_answers, 'showdown');
			$j('#showdown-top-performers').show();
		}

	}).fail(function(xhr) {
		// Don't do anything at this time.
	});
}

function escapeHTML(unsafe) {
	return $j('<div>').text(unsafe).html();
}

function unescapeHTML(safe) {
	return $j('<div>').html(safe).text();
}

function showAnswerAlert(inputBox, alert) {
	if (!(inputBox instanceof jQuery) || !(alert instanceof jQuery)) {
		return;
	}

	alert.show();
	inputBox.addClass('nocursor').trigger('input');

	setTimeout(function() {

		inputBox.removeClass('nocursor').trigger('focus');
		alert.hide();
	}, 400);
}

function updateHeaderStreakMweb(playsToday){
    var streakThumb = $j('.mobile-streak-thumb');
    var headerStreakEl = $j('.mobile-streak-count');
    var currStreak = parseInt(headerStreakEl.text().trim().replace(/,/g, ''));
    var triggerAnimation = playsToday ? 0 : 1;
	var daysUntilCount = $j('#days-until-count');
	var daysUntilTrophyIcon = $j('#days-until-trophy-icon');
    var ddStreakEl = $j('#dd-daily-streak-count');
    var ddPlaysTodayEl = $j('#dd-plays-today-count');
    var ddPlaysTodayLabel = $j('#dd-plays-today-label');
    var flameEl = $j('#streak-flame img');

    playsToday++;

	/*Handle play streak trophy update */
	if (typeof userKey !== 'undefined') {
		var trophy_info = JSON.parse(window.localStorage.getItem(userKey + ':trophy_info'));
		var trophyIcon = ((trophy_info.next.required_count - currStreak - 1) > 0 ? trophy_info.next.icon : trophy_info.following.icon);
		var remaining_count = ((trophy_info.next.required_count - currStreak - 1) > 0 ? (trophy_info.next.required_count - currStreak - 1) : trophy_info.following.required_count - currStreak - 1);
	}

    if(triggerAnimation){
        currStreak++;

        streakThumb.css({
            'background':'url(/images/animatedflame150.gif)',
            'background-size': '28px 28px'
        });

        ddStreakEl.text(currStreak.toLocaleString());
        flameEl.attr('src', '/images/flame-large-color.svg');

		daysUntilCount.text(remaining_count.toLocaleString() + (remaining_count > 1 ? ' days' : ' day'));
		daysUntilTrophyIcon.css('background-image', 'url('+trophyIcon+')');

        setTimeout(function () {
            $j('.mobile-streak-thumb, .mobile-streak-count, .mobile-streak-icon').addClass('on-fire');
            streakThumb.removeAttr('style');
            headerStreakEl.text(' ' + currStreak.toLocaleString());
        }, 1100);
    }

    ddPlaysTodayEl.text(playsToday.toLocaleString());
    ddPlaysTodayLabel.text(playsToday === 1 ? 'PLAY TODAY' : 'PLAYS TODAY');

    if(typeof userKey !== 'undefined'){
        window.localStorage.setItem(userKey + ':streak:plays_today', playsToday);
    }
}

function updateHeaderStreakDsktp(playsToday){
    var dropdown = $j('#streak-dropdown');
    var wrapper = document.querySelector('#streak-wrapper');
    var ddStreakEl = $j('#dd-daily-streak-count');
    var ddPlaysTodayEl = $j('#dd-plays-today-count');
    var ddPlaysTodayLabel = $j('#dd-plays-today-label');
	var daysUntilCount = $j('#days-until-count');
	var daysUntilTrophyIcon = $j('#days-until-trophy-icon');
    var headerStreakEl = $j('#header-streak-count');
    var flameEl = $j('#streak-flame img');
    var streakThumb = $j('#header-streak-thumb');
    var streakBox = $j('#streak-box');

    var currStreak = parseInt(headerStreakEl.text().trim().replace(/,/g, ''));
    var triggerAnimation = playsToday ? 0 : 1;
    playsToday++;

	/*Handle play streak trophy update */
	if (typeof userKey !== 'undefined') {
		var trophy_info = JSON.parse(window.localStorage.getItem(userKey + ':trophy_info'));
		var trophyIcon = ((trophy_info.next.required_count - currStreak - 1) > 0 ? trophy_info.next.icon : trophy_info.following.icon);
		var remaining_count = ((trophy_info.next.required_count - currStreak - 1) > 0 ? (trophy_info.next.required_count - currStreak - 1) : trophy_info.following.required_count - currStreak - 1);
	}


    if(triggerAnimation){
        currStreak++;

        //Preloading animation gif
        $j('<img />').attr('src','/images/animatedflame150.gif').appendTo('body').hide();

        if(!isInViewport(wrapper)){
            dropdown.css({
                'position': 'fixed',
                'top': '0',
                'z-index': '1000',
                'right': '28%'
            });
        } else {
            streakBox.addClass('active');
        }

        dropdown.addClass('visible');

        setTimeout(function () {
            dropdown.fadeOut(600, function () {
                $j(this).removeClass('visible').delay(200).removeAttr('style');
            });
        }, 3950);

        //Start animation for streak icon in header
        setTimeout(function () {
            setTimeout(function () {
                streakBox.removeClass('active');
            }, 100);

            streakThumb.css({
                'background':'url(/images/animatedflame150.gif)',
                'background-size': '36px 34px'
            });

            setTimeout(function () {
                $j('#header-streak-thumb, #header-streak-count, #streak-box').addClass('on-fire');
                streakThumb.removeAttr('style');
                headerStreakEl.text(' ' + formatNumber(currStreak));
            }, 1100);
        }, 4200);
        //End animation for streak icon in header

        //Start animations for dropdown
        setTimeout(function () {
            ddStreakEl.animate({
                'opacity': 0
            }, 600, function () {
                $j(this).text(formatNumber(currStreak));
            }).animate({'opacity': 1}, 600);
        }, 1500);

        setTimeout(function () {
            ddPlaysTodayEl.animate({
                'opacity': 0
            }, 600, function () {
                $j(this).text(formatNumber(playsToday));
                if(playsToday === 1){
                    ddPlaysTodayLabel.text('PLAY TODAY');
                }
            }).animate({'opacity': 1}, 600);
        }, 600);

        setTimeout(function () {
            flameEl.animate({
                'width':'0'
            }, 600, function () {
                $j(this).attr('src', '/images/flame-large-color.svg');
                $j(this).animate({
                    'width':'100%'
                }, 600);
            });
        }, 1500);

		//Only update trophy if local storage is working - otherwise it should update when user refreshed page
		if (typeof userKey !== 'undefined') {
			setTimeout(function () {
	            daysUntilCount.animate({
	                'opacity': 0
	            }, 600, function () {
	                $j(this).text(formatNumber(remaining_count) + (remaining_count > 1 ? ' days' : ' day'));
					daysUntilTrophyIcon.css('background-image', 'url('+trophyIcon+')');
	            }).animate({'opacity': 1}, 600);

	        }, 600);
		}
        //End animations for dropdown
    }

    if(typeof userKey !== 'undefined'){
        window.localStorage.setItem(userKey + ':streak:plays_today', playsToday);
    }
}
