function updateSpan(url, getStr, updateSpanName, callback)
{
	$j('#'+updateSpanName).load(url, getStr, function (response, status, xhr) {
		if(typeof callback == 'function') {
			callback();
		}
	});
}
function init()
{
	$j('.noscript').hide();

	if (window.customInit)
	{
		customInit();
	}
}
window.onload = init;
window.addEventListener('DOMContentLoaded', activateFloatingLabels);
window.addEventListener('pageshow', activateFloatingLabels); //to account for BFCache

var lastAdTimestamp;
$j(function() {
	/* initialize lastAdTimestamp when the DOM first loads */
	var d = new Date();
	lastAdTimestamp = d.getTime();
	
});


function activateFloatingLabels() {
  	var containers = document.querySelectorAll('.floatingLabel');
	var inputs = document.querySelectorAll('.floatingLabel input:not([type=hidden]), .floatingLabel textarea');

  	inputs.forEach(function(ele, idx) {
		var hasFocus = ele === document.activeElement;
  		if(ele.value == '' && containers[idx].classList.contains('isFloating') && !hasFocus){
  			containers[idx].classList.remove('isFloating');
  		} else if (ele.value != '' || hasFocus){
  			containers[idx].classList.add('isFloating');
  		}

  		ele.addEventListener('focus', function(e) {
	    	containers[idx].classList.add('hasFocus');
	   		containers[idx].classList.add('isFloating');
		});
		ele.addEventListener('blur', function(e) {
	    	containers[idx].classList.remove('hasFocus');
	    
			if(e.target.value == '') {
				containers[idx].classList.remove('isFloating');
			}
		});
  	})

}

function connectFBUser() {
	$j.ajax({
		type: "POST",
		url: "/facebook/endpoints/login_fb.php",
		success: function(data) {
			var response = JSON.parse(data);
			// Do nothing on success
			if (response.success != true) {
				if (response.return_type == 'bad_match') {
					FB.logout(function(response) {
						if (response.authResponse) {
							openFBReconnectModal();
						}
					});
				} else {
					SporcleLib.Modal.openFBErrorModal();
				}
			}
		}
	});
}

function openFBReconnectModal() {
	$j.ajax({
		method: "GET",
		url: "/auth/fb_reconnect_modal.php",
		success: function(data) {
			var fbRM = $j(data).remodal({hashTracking:false});
			fbRM.open();

			$j(document).on('closed', '[data-remodal-id=fb_reconnect_modal]', function (e) {
			  	// Doesn't need to be bound inline because a partial disconnect doesn't open the fb popup
			  	// Binding here (instead of on the modal) to catch all close situations, including user clicking outside of modal
			  	if (e.reason != 'confirmation') {
			  		disconnectFBUser("/facebook/endpoints/disconnect_fb.php", null, true);
			  	}
			});
		}
	});
}

function disconnectFBUser(endpoint, redirect, partial_disconnect) {
	FB.getLoginStatus(function(response) {
		if (response.status === 'connected') {
			$j.ajax({
				url: endpoint
			}).done(function(data) {
				var response = JSON.parse(data);
				if ((response['success'] == false) && (response['return_type'] == 'error')) {
					SporcleLib.Modal.openFBErrorModal();
				} else if (response['success'] == true) {
					if (redirect) {
						window.location.replace(redirect);
					} else {
						location.reload();
					}
				}
			});
		} else {
			if (partial_disconnect) {
				$j.ajax({
					url: endpoint,
					data: 'partial_disconnect=true'
				}).done(function(data) {
					var response = JSON.parse(data);
					if ((response['success'] == false) && (response['return_type'] == 'error')) {
						SporcleLib.Modal.openFBErrorModal();
					} else if (response['success'] == true) {
						if (redirect) {
							window.location.replace(redirect);
						} else {
							location.reload();
						}
					}
				});
			} else {
				FB.login(function(response) {
					if (response.status == 'connected') {
						$j.ajax({
							url: endpoint,
						}).done(function(data) {
							var response = JSON.parse(data);
							if ((response['success'] == false) && (response['return_type'] == 'error')) {
								SporcleLib.Modal.openFBErrorModal();
							} else if (response['success'] == true) {
								if (redirect) {
									window.location.replace(redirect);
								} else {
									location.reload();
								}
							}
						});
					}
				});
			}
		}
	});
}

function fbLogin(endpoint, isMobile, regAction, regPath, redirect, querystring, toReplace, loader, switching) {
	if (typeof redirect === "undefined") {
		redirect = window.location.href || "/";
	}
	if (typeof querystring === "undefined") {
		querystring = "";
	}
	if (typeof switching === "undefined") {
		switching = 1;
	}

	FB.getLoginStatus(function(response) {
		var newUserRedirect = "/invite?success=facebook";
		if (response.status === 'connected') {
			if (toReplace && loader) {
				loader.css({
					height  : toReplace.css('height'),
					width   : toReplace.css('width'),
					margin  : toReplace.css('margin'),
					display : toReplace.css('display')
				});
				toReplace.replaceWith(loader);
			}

			$j.ajax({
				url  : endpoint,
				data : {
					reg_path: regPath
				}
			}).done(function(data) {
				var response = JSON.parse(data);
				if ((response['success'] == false) && (response['return_type'] == 'error')) {
					if (typeof SporcleLib != 'undefined') {
						SporcleLib.Modal.openFBErrorModal();
					} else {
						$j('#social-error').html(response['error_message']);
					}
				} else if (response['success'] == true) {
					if ((response['return_type'] == 'new_account') && (response['fb_user_id'])) {
						var fbpic = 'http://graph.facebook.com/'+response['fb_user_id']+'/picture?type=normal&width=150';
						$j.ajax({
							type: "POST",
							url:'/settings/ajax/profile.php',
							data: {upload_user_icon: true, remote_icon: fbpic}
						}).done(function(data) {
							if (isMobile) {
								var href = "/auth/verify-social-connect/";
								window.location.replace(href);
							} else {
								SporcleLib.Modal.openVerifyModal({
									switching: switching,
									registerAction : regAction
								});
							}
						});
					} else {
						var href = redirect+(querystring ? "?"+querystring : "");
						window.location.replace(href);
					}
				}
			});
		} else {
			FB.login(function(response) {
				if (response.status == 'connected') {
					if (toReplace && loader) {
						loader.css({
							height  : toReplace.css('height'),
							width   : toReplace.css('width'),
							margin  : toReplace.css('margin'),
							display : toReplace.css('display')
						});
						toReplace.replaceWith(loader);
					}
					$j.ajax({
						url: endpoint,
						data : {
							reg_path: regPath
						}
					}).done(function(data) {
						var response = JSON.parse(data);
						if ((response['success'] == false) && (response['return_type'] == 'error')) {
							if (typeof SporcleLib != 'undefined') {
								SporcleLib.Modal.openFBErrorModal();
							} else {
								$j('#social-error').html(response['error_message']);
							}
							if (toReplace && loader) {
								loader.replaceWith(toReplace);
							}
						} else if (response['success'] == true) {
							if ((response['return_type'] == 'new_account') && (response['fb_user_id'])) {
								var fbpic = 'http://graph.facebook.com/'+response['fb_user_id']+'/picture?type=normal&width=150';
								$j.ajax({
									type: "POST",
									url:'/settings/ajax/profile.php',
									data: {upload_user_icon: true, remote_icon: fbpic}
								}).done(function(data) {
									if (isMobile) {
										var href = '/auth/verify-social-connect/';
										window.location.replace(href);
									} else {
										SporcleLib.Modal.openVerifyModal({
											switching: switching,
											registerAction : regAction
										});
									}
								});
							} else {
								var href = redirect+(querystring ? "?"+querystring : "");
								window.location.replace(href);
							}
						}
					});
				}
			}, {scope: 'email'});
		}
	});
}

function fbReAuth(regPath, redirect) {
	FB.login(function(response) {
		$j.ajax({
			url: "/facebook/endpoints/connect_fb.php",
			data : {
				second_attempt: 1,
				reg_path: regPath
			}
		}).done(function(data) {
			var response = JSON.parse(data);
			if ((response['success'] == false) && (response['return_type'] == 'error')) {
				SporcleLib.Modal.openFBErrorModal();
			} else if (response['success'] == true) {
				if (redirect) {
					window.location.replace(redirect);
				} else {
					location.reload();
				}
			}
		});
	}, {scope: 'email', auth_type: 'rerequest' });
}

function googleDisconnect() {
	$j.ajax({
		url: "/google/endpoints/disconnect_google_user.php"
	}).done(function(data) {
		var response = JSON.parse(data);
		if ((response['success'] == false) && (response['return_type'] == 'error')) {
			SporcleLib.Modal.openGoogleErrorModal();
		} else if (response['success'] == true) {
			location.reload();
		}
	});
}

function attemptLogin(email, pass, remember, callback) {
	$j.ajax({
		method: 'post',
		url: '/auth/ajax/login.php',
		data: {
			'email': email,
			'passwd': pass,
			'remember': remember ? 1 : 0,
		}
	}).done(function (data) {
		if (typeof callback == 'function') {
			callback(data);
		} else {
			/* if no callback defined, just refresh the page on successful login */
			if (data.success === true && data.logged_in === true) {
				window.location.reload();
			}
		}
	}).fail(function () {
		if (typeof callback == 'function') {
			callback({success: false, logged_in: false, error_text: "There was an error, please try again"});
		} else {
			/* don't know what to do with the error message */
		}
	});
}

function countLength(event, element, label, count_num)
{
	if(typeof count_num == 'undefined')
	{
		count_num = 250;
	}
	if(element.value.length >= count_num && event)
	{
		element.value = element.value.substr(0, count_num);
		if(event.which != 8 && event.keyCode != 8)
		{
			event.preventDefault();
			event.stop();
		}
	}
	$j('#'+label).html(element.value.length);
}

function moreGames(leaderboard_id, start, amount, category_id, element)
{
	updateSpan('/quizzes/', 'loadmore=1&s='+start+'&a='+amount+'&l='+leaderboard_id+'&c='+category_id+'&href='+document.location.href.replace(/^(?:\/\/|[^\/]+)*\//, ""), element);
}

function isInViewport(elem)
{
    var bounding = elem.getBoundingClientRect();
    return (
        bounding.top >= 0 &&
        bounding.left >= 0 &&
        bounding.bottom <= (window.innerHeight || document.documentElement.clientHeight) &&
        bounding.right <= (window.innerWidth || document.documentElement.clientWidth)
    );
}

function formatNumber(number)
{
    number += '';
	if(number.indexOf('.') != -1) {
		number = parseFloat(number).toFixed(2);
	}
    x = number.split('.');
	x1 = x[0];
	x2 = x.length > 1 ? '.' + x[1] : '';
    var rgx = /(\d+)(\d{3})/;
	while (rgx.test(x1)) {
		x1 = x1.replace(rgx, '$1' + ',' + '$2');
	}
    return x1+x2;
}

function formatTime(time) {
	time = Math.round(time);
	var hours = String("00" + (Math.floor(time / 3600))).slice(-2);
	var minutes = String("00" + (Math.floor(time / 60) % 60)).slice(-2);
	var seconds = String("00" + (time % 60)).slice(-2);

	if (hours != '00') {
		return hours+":"+minutes+":"+seconds;
	} else {
		return minutes+":"+seconds;
	}
}

//formats time in seconds to XXh XXm
function formatTimeHoursMins(time) {
	hours = Math.floor(time / 3600);
	time %= 3600;
	minutes = Math.round(time / 60);
	return hours == 0 ? minutes+'m' : hours+'h '+minutes+'m'
}

_spAjaxQueue = function() {
	// Arbitrarily high, currently the most we expect is 13 on the game page for an orange user
	var maxChunkSize = 50;

	var reqList = [];
	return {
		push: function(req) {
			if(typeof req.length == 'undefined') {
				reqList.push(req);
			} else {
				var rlen = req.length;
				for(var i = 0; i < rlen; i++) {
					reqList.push(req[i]);
				}
			}
		},
		send: function() {
			var chunks = [];
			var chunkIndex = 0; // Which chunk we are currently adding to
			var chunkSize = 0;  // How many reqs are in the current chunk
			reqList.forEach(function(req) {
				if (chunkSize >= maxChunkSize) {
					chunkSize = 0;
					chunkIndex++;
				}

				if (chunkIndex >= chunks.length) {
					chunks[chunkIndex] = {};	// Create new chunk of reqs
				}

				// Add req to current chunk
				chunks[chunkIndex][req['ref']] = req;
				chunkSize++;
			});

			chunks.forEach(this.sendChunk, this);
		},
		sendChunk: function(chunk) {
			if (!$j.isEmptyObject(chunk)) {
				$j.ajax({
					url: '/includes/ajaxqueue.php',
					type: 'post',
					data: "req=" + encodeURIComponent(JSON.stringify(chunk)),
					dataType: 'json'
				}).done(function(data, textstatus, request) {
					$j.each(chunk, function(i,v){
						(v['callback'] || function(){})(data[v['ref']]);
					});
				});
			}
		}
	}
};

function parseAjaxQueueResponse(data) {
	try {
		if (data && data.hasOwnProperty('result')) {
			var result = JSON.parse(data.result);
			if (result) {
				return result;
			}
		}
	} catch (err) {}

	return null;
}

/* Follow */
function followUser(followUserID, showAlert, element, callback) {

    function sendRequest() {
        $j.ajax({
            url: '/ajax/follow_user.php',
            type: 'post',
            data: {
                'follow_user':followUserID
            }
        }).done( function(data) {
            data = JSON.parse(data);
            if(callback) {
                callback(data, followUserID, element);
            }
        }).fail(function() {
            var data  = {success:false};
            if (callback) {
                callback(data, followUserID, element);
            }
        });
    }

	if(showAlert){
        window.SporcleLib.Modal.openConfirmationModal({
            msg: 'Are you sure you want to unfollow this user?',
            onYes: function (remodal) {
                sendRequest();
                remodal.close();
            }
        });
    } else {
        sendRequest();
    }
}

/* Used to attach the follow button to game pages */
function updateFollow(data) {
	$j('#follow-box').html(data);
	$j('#follow-box').show();
}

/* Block */
function blockUser(blockUserID, element, callback) {
	$j.ajax({
		url: '/ajax/block_user.php',
		type: 'post',
		data: {
			'block_user':blockUserID
		}
	}).done( function(data) {
		data = JSON.parse(data);

		var message = data.blocked ? 'This user has been successfully blocked' : (data.unblocked ? 'This user has been successfully unblocked' : '');
        if(message) showMainPageAlert(message, {type: 'success'});

		if(callback) {
			callback(data, blockUserID, element);
		}
	}).fail(function() {
		var data  = {success:false};

		var message = "We encountered an error processing your block request. Please write <a href='/feedback/'>feedback</a> if you continue to experience this issue.";
        showMainPageAlert(message, {type: 'danger'});

		if (callback) {
			callback(data, blockUserID, element);
		}
	});
}

/* Challenge Block */
function challengeBlockUser(blockUserID, element, callback) {
	$j.ajax({
		url: '/ajax/challenge_block_user.php',
		type: 'post',
		data: {
			'block_user':blockUserID
		}
	}).done( function(data) {
		data = JSON.parse(data);

		var message = data.blocked ? 'This user has been successfully blocked from sending you challenges.' : (data.unblocked ? 'This user has been successfully unblocked from sending you challenges.' : '');
        if(message) showMainPageAlert(message, {type: 'success'});

		if(callback) {
			callback(data, blockUserID, element);
		}
	}).fail(function() {
		var data  = {success:false};

		var message = "We encountered an error processing your challenge block request. Please write <a href='/feedback/'>feedback</a> if you continue to experience this issue.";
        showMainPageAlert(message, {type: 'danger'});

		if (callback) {
			callback(data, blockUserID, element);
		}
	});
}

/* Opens a new window to send the given user a message */
function sendUserMessage(recipientHandle, form) {
	var dualScreenLeft = window.screenLeft != undefined ? window.screenLeft : screen.left;
	var dualScreenTop = window.screenTop != undefined ? window.screenTop : screen.top;

	width = window.innerWidth ? window.innerWidth : document.documentElement.clientWidth ? document.documentElement.clientWidth : screen.width;
	height = window.innerHeight ? window.innerHeight : document.documentElement.clientHeight ? document.documentElement.clientHeight : screen.height;

	var left = ((width / 2) - (550 / 2)) + dualScreenLeft;
	var top = ((height / 2) - (600 / 4)) + dualScreenTop;
	var windowSizeParam = 'height=600,width=550,top='+top+',left='+left;

	if(recipientHandle){
	    $j('<input type="hidden" name="recipient" value="'+recipientHandle+'">').appendTo(form);
    }

    if((form.attr('name')) === 'send-quiz-message'){

        $j('<input type="hidden" name="subject" value="Check out this quiz!">').appendTo(form);

        $j('<input type="hidden" name="message_body" value="Hey!\n\nI thought you might like this quiz: [' + window.gameNameDesc + '](https://www.sporcle.com' + window.gameurl + '). Let me know what you think! \n\n{{FROM_HANDLE}}">').appendTo(form);

        $j('<input type="hidden" name="message_source" value="quiz_page_message_icon">').appendTo(form);

    }

    form.prop("target", "send-message");
	window.open("", "send-message", windowSizeParam);
	form.trigger('submit');
}

/* jQuery plugin to parse the querystring, since jQuery doesn't have one.
adapted from here: http://stackoverflow.com/questions/901115/how-can-i-get-query-string-values-in-javascript */
(function($j) {
	$j.parseQueryString = function() {
		var qs = window.location.search.substr(1).split('&');
		var obj = {};
		for (var i = 0; i < qs.length; ++i) {
			var p = qs[i].split('=');
			if (p.length !== 2) {
				continue;
			}
			obj[p[0]] = decodeURIComponent(p[1].replace(/\+/g, " "));
		}
		return obj;
	};
})(jQuery);

$j(function () {
    $j('#searchIcon').on('click', function() {
        $j('#sporcle-search').trigger('submit');
    })
});

/* User Box, Notifications, and Play Streak */
function toggleUserDropdown(event) {
	event.stopPropagation();

	$j('#userNav-thumb, #userNav-box').toggleClass('active');
	$j('#userNav-dropdown').toggleClass('visible');
	$j('#notifications-thumb, #notifications-box, #streak-box').removeClass('active');
	$j('#notifications-box, #streak-box').attr('aria-expanded', 'false')
	$j('#notifications-dropdown').removeClass('visible');
    $j('#streak-dropdown').removeClass('visible');
	toggleAriaExpanded('#userNav-box', 'aria-expanded');
}

function toggleNotificationDropdown(event, notificationCount, newNotificationCount, messagesCount, newMessageCount) {
	event.stopPropagation();

	var showNotificationsTab = (!newMessageCount && newNotificationCount) || (messagesLoaded && newNotificationCount && !notificationsLoaded) || (!newNotificationCount && !newMessageCount);

	if(showNotificationsTab){
        $j('#notifications-tab-count').hide();
    } else {
        $j('#messages-tab-count').hide();
    }

	$j('#userNav-thumb, #streak-box, #userNav-box').removeClass('active');
	$j('#userNav-dropdown').removeClass('visible');
	$j('#userNav-box, streak-box').attr("aria-expanded", "false");
	$j('#notifications-thumb').toggleClass('active');
	$j('#notifications-dropdown').toggleClass('visible');
    $j('#streak-dropdown').removeClass('visible');

    var loggedIn = typeof userKey !== 'undefined' && userKey;

    if(showNotificationsTab){
        $j("#messages-tab h3").removeClass('active');
        $j("#notifications-tab h3").addClass('active');
        if(loggedIn) getNotificationsForDropdown(newNotificationCount);
    } else {
        $j("#messages-tab h3").addClass('active');
		$j("#notifications-tab h3").removeClass('active');
        if(loggedIn) getMessagesForDropdown(newMessageCount);
    }

    $j('#messages-tab').on('click', messageDropdownEvent);
    $j('#messages-tab').on('keydown', e => {
		if (e.keyCode === 13) messageDropdownEvent();
	});
	
    $j('#notifications-tab').on('click', notificationDropdownEvent);
    $j('#notifications-tab').on('keydown', e => {
		if (e.keyCode === 13) notificationDropdownEvent();
	});

	if ($j('#notifications-dropdown').hasClass('visible')) {
		ga('send','event','Notifications','Icon Click');
	}

	function messageDropdownEvent() {
		$j('#notifications-tab h3').removeClass('active');
		$j('#messages-tab h3').addClass('active');
		if(loggedIn) getMessagesForDropdown(newMessageCount);
	}

	function notificationDropdownEvent() {
        $j('#messages-tab h3').removeClass('active');
        $j('#notifications-tab h3').addClass('active');
        if(loggedIn) getNotificationsForDropdown(newNotificationCount);
    }
}

function toggleStreakDropdown() {
	const streakBox = $j('#streak-box');
	const streakDropdown = $j('#streak-dropdown');

    $j('#userNav-thumb, #notifications-thumb, #notifications-box, #userNav-box').removeClass('active');
    $j('#userNav-dropdown, #notifications-dropdown').removeClass('visible');
    streakBox.toggleClass('active');
    streakDropdown.toggleClass('visible');
	toggleAriaExpanded('#streak-box');

    if (streakDropdown.hasClass('visible')) {
        ga('send','event','Desktop Header','Play Streak');
    }
}

function renderNotificationsHTML(notifications, template) {
	var rendered = [];
	_.each(notifications, function(_n) {
		rendered.push(_.template(template)(_n));
	});

	return rendered.join('');
}

function bookmarkNotificationItem(el, id, idType, bookmarked) {
	var $el = $j(el);
	var bData = {};
	bData['bookmark_' + idType] = id;

	var titleItem;

	if (idType === 'game_id') {
		titleItem = 'Quiz';
	} else if (idType === 'badge_id') {
		titleItem = 'Badge';
	} else if (idType === 'topic_id') {
		titleItem = 'Topic';
	} else if (idType === 'playlist_id') {
		titleItem = 'Playlist';
	}

	$j.ajax({
		url: '/ajax/bookmark.php',
		type: 'post',
		data: bData,
		success: function(data) {
			data = JSON.parse(data);

			if (data.bookmarked) {
				$el.addClass('bookmarked');
				$el.attr('title', 'Bookmarked');
			} else if (data.unbookmarked) {
				$el.removeClass('bookmarked');
				$el.attr('title', 'Bookmark this ' + titleItem);
			}

			// Remove the cached html otherwise clicking back into the notifications shows
			// the item in the previous bookmark state
			notificationsHTML = false;

			if (callback) {
				callback();
			}
		},
		error: function(data) {
            data = JSON.parse(data.responseText);
            showMainPageAlert(data.error, {type:'danger', dismissible:true});
		}
	});
}

function clickBadgeBookmark(e){
	$j.ajax({
		url: '/ajax/bookmark.php',
		type: 'post',
		data: {bookmark_badge_id: $j(e).attr('id')},
		success: function(data) {
			data = JSON.parse(data);
			if (data.bookmarked) {
				$j(e).addClass('bookmarked');
			} else if (data.unbookmarked) {
				$j(e).removeClass('bookmarked');
			}
		},
		error: function(data) {
            data = JSON.parse(data.responseText);
            showMainPageAlert(data.error, {type:'danger', dismissible:true});
		}
	});
};

function getNotificationsForDropdown(newNotificationsCount) {
    var container = $j('#alert-content-wrapper');
    $j('#seeAll').html('<a href="/notifications/" onclick="ga(\'send\',\'event\',\'Notifications\',\'See All\');">See all notifications</a>');

	tabOutOfDropdownEventListener('#seeAll a', escapeNotificationDropdown);

	if (notificationsLoaded && notificationsHTML) {
        container.html(notificationsHTML);

		escapeDropdownEventListener('#notifications-dropdown a', '#notifications-box', escapeNotificationDropdown);
		
        return;
	}

	container.html('<li><img id="notifications-loading" src="/images/ajax-loader-transparent.gif" style="display:block;margin:auto;"></li>');

	/* Set the flag to true now because we don't want to try to load it more than once, even if it fails to load */
	notificationsLoaded = true;

	var jqXHR = $j.ajax({
		url: '/ajax/user_notifications.php',
		method: 'get',
		data: {r: 'dropdown'}
	}).done(function (data) {
		if (data.notifications.length) {
			var template = $j('#notification-dropdown-template').html();
			notificationsHTML = renderNotificationsHTML(data.notifications, template);
		} else {
			notificationsHTML = '<li>You have no&nbsp;<a href="/notifications" onclick="ga(\'send\',\'event\',\'Notifications\',\'Notification Click\');">notifications</a>&nbsp;at this time.</li>';
		}
	}).fail(function () {
		notificationsHTML = '<li>Unable to load&nbsp;<a href="/notifications" onclick="ga(\'send\',\'event\',\'Notifications\',\'Notification Click\');">notifications</a>&nbsp;at this time.</li>';
	}).always(function() {
        $j('#notifications-tab-count').hide();
        removeCountFromTitle();
        container.html(notificationsHTML);

		escapeDropdownEventListener('#notifications-dropdown a', '#notifications-box', escapeNotificationDropdown);

        remainingNewAlerts -= newNotificationsCount;
        if(remainingNewAlerts){
            $j('#notifications_count').html(remainingNewAlerts);
        } else {
            $j('#notifications_count').hide();
        }
    })
}

function getTitleWithoutCount() {
	return document.title.replace(/^\(\d+\) /,"");
}

function removeCountFromTitle() {
	document.title = getTitleWithoutCount();
}

function addCountToTitle(count) {
	if (parseInt(count) == count) {
		document.title = "("+count+") "+getTitleWithoutCount();
	}
}

function renderMessagesHTML(messages, template) {
	var rendered = [];
	_.each(messages, function(_m) {
		rendered.push(_.template(template)(_m));
	});

	return rendered.join('');
}

function getMessagesForDropdown(newMessagesCount) {
    var container = $j('#alert-content-wrapper');
    $j('#seeAll').html('<div id="user-box-messages-actions"><a href="/messages/" onclick="ga(\'send\',\'event\',\'Messages\',\'Go to Inbox\');">Go to Inbox</a><a tabindex="0" id="user-box-compose" onclick="compose()">Compose Message</a></div>');

    if (messagesLoaded && messagesHTML) {
		container.html(messagesHTML);
		escapeDropdownEventListener('#notifications-dropdown a', '#notifications-box', escapeNotificationDropdown);
		composeMessageEventListener();
		return;
	}

    container.html('<li><img id="messages-loading" src="/images/ajax-loader-transparent.gif" style="display:block;margin:auto;"></li>');

	/* Set the flag to true now because we don't want to try to load it more than once, even if it fails to load */
	messagesLoaded = true;

	var jqXHR = $j.ajax({
		url: '/ajax/user_messages.php',
		method: 'get',
		data: {dropdown: 'true'}
	}).done(function (data) {
        if (typeof(data.messages) != 'undefined' && Object.keys(data.messages).length) {
			var template = $j('#message-dropdown-template').html();
			messagesHTML = renderMessagesHTML(data.messages, template);
		} else {
			if (typeof(data.user_unverified) != 'undefined' && data.user_unverified && data.user_email != 'undefined') {
                messagesHTML = '<li>Sending messages is for verified users.</li>';
			} else {
                messagesHTML = '<li>You have no&nbsp;<a href="/messages">messages</a>&nbsp;at this time.</li>';
			}
		}
	}).fail(function () {
        messagesHTML = '<li>Unable to load&nbsp;<a href="/messages" at this time.</li>';
	}).always(function() {
        $j('#messages-tab-count').hide();
        container.html(messagesHTML);
        $j('#seeAll').html('<div id="user-box-messages-actions"><a href="/messages/" onclick="ga(\'send\',\'event\',\'Messages\',\'Go to Inbox\');">Go to Inbox</a><a tabindex="0" id="user-box-compose" onclick="compose()">Compose Message</a></div>');
        remainingNewAlerts -= newMessagesCount;

		escapeDropdownEventListener('#notifications-dropdown a', '#notifications-box', escapeNotificationDropdown);
		composeMessageEventListener();

        if(remainingNewAlerts){
            $j('#notifications_count').html(remainingNewAlerts);
        } else {
            $j('#notifications_count').hide();
        }
    });
}

function initializeUserBox(result) {
	/* JSON parse the ajax result, can stop this once we migrate the ajax queue to jquery instead of prototype */
	try {
		result = JSON.parse(result);
	} catch(e) {
		result = {html: "", notification_count: 0};
	}

    if (result.html.length > 0) {
		$j('#user-box').html(result.html);
	}


    if(result.new_notifications_count){
        $j("#notifications-tab-count").html(result.new_notifications_count).show();
    }

    if(result.new_message_count){
        $j("#messages-tab-count").html(result.new_message_count).show();
    }

	if (remainingNewAlerts) {
		$j('#notifications_count').show();
		addCountToTitle(remainingNewAlerts);
	}

	/* Setup click handlers for user nav drop down */
	$j('#userNav-box.logged-in').on('click', toggleUserDropdown);

	$j('#user-not-logged-in').on('click', function() {
		window.SporcleLib.Modal.openLoginModal({
			analyticAction : "Header Login",
			regPath        : "main_header_login"
		});

	});

    /* Setup click handlers for drop downs */
    $j('#notifications-box').on('click', function(e){
        escapeNotificationDropdown(e, result)
    });

	$j('#notifications-dropdown').on('click', function(event) {
		event.stopPropagation();
	});

    $j('#streak-box').on('click', function(e){
        const streakDropdown = $j('#streak-dropdown');
        if (streakDropdown.hasClass('visible')) {
            streakDropdown.removeClass('visible');
        } else {
            e.stopPropagation();
            getLatestPlaysToday(toggleStreakDropdown);
        }
    });

    $j('#streak-dropdown').on('click', function(event) {
        event.stopPropagation();
    });

	$j(document).on('click', function(){
		$j('#notifications-dropdown, #userNav-dropdown, #streak-dropdown').removeClass('visible');
		$j('#notifications-thumb, #userNav-thumb, #streak-box, #notifications-box, #userNav-box').removeClass('active');
		$j('#streak-box, #notifications-box, #userNav-box').attr('aria-expanded', 'false');
		$j('#notifications-tab h3').removeClass('active');
        $j('#messages-tab h3').addClass('active');
	});

	/* Set up keydown handlers for dropdowns */
	tabOutOfDropdownEventListener('#userNav-content li', toggleUserDropdown);

	escapeDropdownEventListener('#userNav-dropdown h4 a, #userNav-content li', '#userNav-box', toggleUserDropdown);

	escapeDropdownEventListener('#notifications-dropdown .tabs span', '#notifications-box', escapeNotificationDropdown);

	thumbKeyDownEventListener('#userNav-box.logged-in', '#userNav-thumb, #userNav-box', toggleUserDropdown);

	thumbKeyDownEventListener('#notifications-box', '#notifications-box', escapeNotificationDropdown, result);

	$j('#streak-box').on('keydown', function(e){
		if (e.keyCode === 9 || e.keyCode === 27) {
			$j('#streak-box').removeClass('active').attr('aria-expanded', 'false');
			$j('#streak-dropdown').removeClass('visible');
		}
    });
}

function showMainPageAlert(msg, options) {
	/* default options
	 type = info
	 dismissible = true;
	 fadeOut = true;
	 */
	window.app = window.app || {};
	app.env = app.env || {};
	clearTimeout(app.env.pageAlertTimer);

	if (typeof options === 'undefined') options = {};

	var $pageAlert = $j('#main-page-alert');
	var $pageAlertWrapper = $j('#main-page-alert-wrapper');

	$pageAlert.html("<span class='alert-message'></span><span class='close-alert'></span>");

	msg = msg.replace('feedback@sporcle.com', '<a target=\"_blank\" href=\"mailto:feedback@sporcle.com\">feedback@sporcle.com</a>');
	$pageAlert.find('.alert-message').html(msg);

	var className = 'alertNeutral';
	if (options.hasOwnProperty('type')) {
		switch (options.type) {
			case 'success':
				className = 'alertGood';
				break;
			case 'danger':
				className = 'alertBad';
				break;
			case 'info':
				className = 'alertNeutral';
				break;
			case 'wait':
				className = 'alertLoading';
				break;
		}
	}
	$pageAlert.removeClass().addClass(className);

	if (!options.hasOwnProperty('dismissible') || options.dismissible) {
		$pageAlert.find('.close-alert').html('&times;').on('click', clearMainPageAlert);
	}

	$pageAlertWrapper.show();

	if (!options.hasOwnProperty('fadeOut') || options.fadeOut) {
		app.env.pageAlertTimer = setTimeout(function() {
			$pageAlertWrapper.fadeOut(600);
		}, 5000);
	}
}

function clearMainPageAlert() {
	window.app = window.app || {};
	app.env = app.env || {};
	clearTimeout(app.env.pageAlertTimer);

	$j('#main-page-alert-wrapper').hide();
	$j('#main-page-alert').removeClass().empty();
}

function showPageAlert(msg, options) {
	/* default options
		type = info
		dismissible = false;
		fadeOut = false;
	 */
	if (typeof options === 'undefined') options = {};

	var $pageAlert = $j('#page-alert');
	$pageAlert.html("<span class='alert-message'></span><span class='close-alert'></span>");

	msg = msg.replace('feedback@sporcle.com', '<a target=\"_blank\" href=\"mailto:feedback@sporcle.com\">feedback@sporcle.com</a>');
	$pageAlert.find('.alert-message').html(msg);

	var className = 'alertNeutral';
	if (options.hasOwnProperty('type')) {
		switch (options.type) {
			case 'success':
				className = 'alertGood';
				break;
			case 'danger':
				className = 'alertBad';
				break;
			case 'info':
				className = 'alertNeutral';
				break;
			case 'wait':
				className = 'alertLoading';
				break;
		}
	}
	$pageAlert.removeClass().addClass(className);

	if (options.hasOwnProperty('dismissible') && options.dismissible) {
		$pageAlert.find('.close-alert').html('&times;').on('click', clearPageAlert);
	}

	$pageAlert.show();

	if (options.hasOwnProperty('fadeOut') && options.fadeOut) {
		setTimeout(function() {
			$pageAlert.fadeOut(600);
		}, 5000);
	}
}

function clearPageAlert() {
	$j('#page-alert').hide().removeClass().empty();
}

function shareOnFacebook(url, campaign, quote) {
	quote = quote || null;
	FB.ui({
		method: 'share',
		display: 'popup',
		href: encodeURI(url+'?utm_source=facebook&utm_medium=share&utm_campaign='+campaign),
		hashtag: '#sporcle',
		quote: quote,
	}, function(response){});
}

function shareOnTwitter(name, url, campaign) {
	var dualScreenLeft = window.screenLeft != undefined ? window.screenLeft : screen.left;
	var dualScreenTop = window.screenTop != undefined ? window.screenTop : screen.top;

	width = window.innerWidth ? window.innerWidth : document.documentElement.clientWidth ? document.documentElement.clientWidth : screen.width;
	height = window.innerHeight ? window.innerHeight : document.documentElement.clientHeight ? document.documentElement.clientHeight : screen.height;

	var left = ((width / 2) - (550 / 2)) + dualScreenLeft;
	var top = ((height / 2) - (600 / 4)) + dualScreenTop;
	var windowSizeParam = 'height=600,width=550,top='+top+',left='+left;

	var twitterURL = 'https://twitter.com/intent/tweet?original_referer='+encodeURIComponent(url)
		+'&amp;text='+encodeURIComponent(name)
		+'&amp;url='+encodeURIComponent(url+'?utm_source=twitter&utm_medium=share&utm_campaign='+campaign);

	window.open(twitterURL, '', windowSizeParam);
}

function copyGame(gameID) {
    window.SporcleLib.Modal.openConfirmationModal({
        msg: 'Would you like to create a copy of this quiz?',
        onYes: function (remodal) {
            var params = 'game_id='+gameID;
            $j.ajax({url:'/create/copygame.php',
                type: 'post',
                data: params,
                dataType: 'json'
            }).done(function(data) {
                if (data.success) {
                    window.location = '/create/edit/'+data.message;
                } else {
                    if ($j('#updateAlert').length) {
                        $j('#updateAlert').addClass('alertBad').html(data.message).show().fadeOut(5000);
                    } else {
                        showMainPageAlert(data.message, { type:'danger', dismissible:true });
                    }
                }
            });
            remodal.close();
        }
    });
}


$j(function() {
	// Set up the modal to report a user
	window.reportUserModal = {selector: '#report-user-modal'};
	reportUserModal.$el = $j(reportUserModal.selector);
    reportUserModal.modal = reportUserModal.$el.remodal({hashTracking:false});

	// Set up validator for the report user modal
	var validator = reportUserModal.$el.find('.report-form').validate({
		errorElement: "div",
		errorClass: "err",
		errorPlacement: function(error, element) {
			error.insertBefore(element);
		},
		rules: {
			feedback: {
				required: true,
				maxlength: 255
			}
		},
		messages: {
			feedback: {
				require: "Missing required details",
				maxlength: "Can't be longer than 255 characters"
			}
		},
		submitHandler: function(form) {
			reportUser(
				reportUserModal.modal,
				this,
				reportUserModal.$el.data('user_id'),
				reportUserModal.$el.find('.feedback').val(),
				reportUserModal.$el.data('source'),
				reportUserModal.$el.data('thread_id'),
				reportUserModal.$el.data('context'),
				reportUserModal.$el.data('context_id')
			);
		}
	});

	// Clean up the modal on closing
	$j(document).on('closing', '#report-user-modal', function (e) {
		reportUserModal.$el.removeData(['user_id', 'source', 'thread_id', 'context']).find('.feedback').val('');
		validator.resetForm();
	});

	//Set up suggestion bar events
    setupSuggestionBar();
	setupPromo();
});

function reportUser(modal, validator, userID, feedback, source, threadID, context, contextID) {
	var params = {
		user_id    : userID,
		feedback   : feedback,
		source     : source,
		context_id : contextID
	};

	if (typeof threadID !== 'undefined' && threadID) {
		params.thread_id = threadID;
	}

	if (typeof context !== 'undefined' && context) {
		params.context = context;
	}

	$j.ajax({
		url: '/ajax/report_user.php',
		type: 'post',
		data: params
	}).done(function() {
		modal.close();
		var msg = "User successfully reported.";
		showMainPageAlert(msg, {type:'success',fadeOut:true});
	}).fail(function(xhr) {
		if (_.has(xhr, 'responseJSON') && _.has(xhr.responseJSON, 'validation_errors')) {
			validator.showErrors(xhr.responseJSON.validation_errors);
		} else {
			modal.close();
			var msg = "Oops, something went wrong. Please try again and contact support if the problem persists.";
            if(xhr.responseJSON && xhr.responseJSON.error){
			    msg = xhr.responseJSON.error;
            } else if (xhr.responseText){
                msg = xhr.responseText;
            }
			showMainPageAlert(msg, {type:'danger',fadeOut:true});
		}
	});
}

function isValidEmail(email) {
    var re = /^(([^<>()\[\]\\.,;:\s@"]+(\.[^<>()\[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;
    return re.test(String(email).toLowerCase());
}

function setupSuggestionBar(){
    //Attach event listeners to Suggestion Bar
    var sbar = $j('#suggestions-bar');
    $j('#collapse-bar-icon').on('click', function(e){
        var cookieName = 'sb_view_mode';
        var expireTime = 365 * 2; //two years. Hopefully they've accomplished the suggested actions by then

        if(sbar.hasClass('sb-expanded')){
            sbar.addClass('sb-collapsed').removeClass('sb-expanded');
            setCookie(cookieName, 'sb-collapsed', expireTime);
        } else if(sbar.hasClass('sb-collapsed')){
            sbar.addClass('sb-expanded').removeClass('sb-collapsed');
            setCookie(cookieName, 'sb-expanded', expireTime)
        }

    });

    $j('#hide-bar-link').on('click', function () {
        var args = {
            onYes: function (remodal) {
                $j.ajax({
                    type: "GET",
                    url: "/ajax/user_settings.php",
                    data: {hwb: window.userKey},
                }).done(function(response) {
                    if(response.success){
                        window.location.reload();
                    } else {
                        showMainPageAlert("Oops, something went wrong. Please refresh and try again.", {type:'danger'});
                    }
                }).fail(function(response) {
                    response = (response.responseJSON ? response.responseJSON : response);
                    if (response.error && typeof(response.error) === 'string' && response.error !== '') {
                        showMainPageAlert(response.error, {type:'danger'});
                    } else if (response.message && typeof(response.message) === 'string' && response.message !== '') {
                        showMainPageAlert(response.message, {type:'danger'});
                    } else {
                        showMainPageAlert("Oops, something went wrong. Please refresh and try again.", {type:'danger'});
                    }
                }).always(function () {

                    remodal.close();

                });
            },
            msg: 'Are you sure you want to hide the new user welcome bar?'
        };

        window.SporcleLib.Modal.openConfirmationModal(args);
    });

    if(typeof window.sbData !== 'undefined' && $j('.suggested-action.badge').length){
        $j('.suggested-action.badge').each(function (index, actionElement) {
            var self = $j(actionElement);
            var actionID = (self.attr('id').split('-'))[1];
            var tooltipData = window.sbData[actionID]['tooltip_data'];
            var el = $j(actionElement).find('.suggested-action-progress');
            if(el.length){
                setupSuggestedActionProgressTooltip($j(el), tooltipData,  $j('#suggested-action-tooltip-template'));
            }
        })
    }
}

function setCookie(name,value,days) {
    var expires = "";
    if (days) {
        var date = new Date();
        date.setTime(date.getTime() + (days*24*60*60*1000));
        expires = "; expires=" + date.toUTCString();
    }
    document.cookie = name + "=" + (value || "")  + expires + "; path=/";
}
function getCookie(name) {
    var nameEQ = name + "=";
    var ca = document.cookie.split(';');
    for(var i=0;i < ca.length;i++) {
        var c = ca[i];
        while (c.charAt(0)==' ') c = c.substring(1,c.length);
        if (c.indexOf(nameEQ) == 0) return c.substring(nameEQ.length,c.length);
    }
    return null;
}

function compose() {
    var dualScreenLeft = window.screenLeft != undefined ? window.screenLeft : screen.left;
    var dualScreenTop = window.screenTop != undefined ? window.screenTop : screen.top;

    var width = window.innerWidth ? window.innerWidth : document.documentElement.clientWidth ? document.documentElement.clientWidth : screen.width;
    var height = window.innerHeight ? window.innerHeight : document.documentElement.clientHeight ? document.documentElement.clientHeight : screen.height;

    var left = ((width / 2) - (550 / 2)) + dualScreenLeft;
    var top = ((height / 2) - (600 / 4)) + dualScreenTop;
    var windowSizeParam = 'height=600,width=550,top='+top+',left='+left;

    window.open('/messages/new', 'compose', windowSizeParam);
}

function setupSuggestedActionProgressTooltip(element, data, template) {
    var renderedTemplate = _.template(template.html());

    var conditions = Object.keys(data).map(function(id) {
        return data[id];
    }).sort(function (a, b) {
        return a.complete > b.complete ? 1 : -1;
    });

    var tooltipHtml = $j(renderedTemplate({
        conditions: conditions
    }));

    var thisOpenTip = new Opentip(element, tooltipHtml.html(), {
            stem: 'bottom',
            stemLength: 20,
            stemBase: 30,
            fixed: true,
            target: element,
            targetJoint: 'top',
            tipJoint: 'bottom',
            hideTriggers: ['tip', 'target'],
            hideOn: 'mouseout',
            hideDelay: 0.2,
            group: 'badges',
            borderWidth: 0,
            background: 'white',
            borderColor: '#dddddd',
            borderWidth: 5,
            shadowOffset: [10,10],
            shadowBlur: 5,
            showEffect: 'slide',
            showEffectDuration: 0.1,
            removeElementsOnHide: true,
            hideEffectDuration: 0.1
        }
    );

    var oldHide = thisOpenTip.hide;
    thisOpenTip.hide = function() {
        thisOpenTip.hide = oldHide;
        thisOpenTip.hide();
        thisOpenTip.setContent(tooltipHtml);
        thisOpenTip.hide = arguments.callee;
    };
}

function updateSuggestionsBar(actionID, completedConditionID){
    var actionElement = $j('.suggested-action#action-' + actionID);
    if(
        actionElement.length &&
        !actionElement.hasClass('accomplished') &&
        (typeof window.userKey !== 'undefined' || typeof window.userID !== 'undefined') &&
        (typeof window.stopwatch === 'undefined' || !window.stopwatch) &&
        typeof window.sbData !== 'undefined' &&
        window.sbData[actionID] && window.sbData[actionID]['user_conditions_left_per_action']
    ){

        var conditionsLeft = window.sbData[actionID]['user_conditions_left_per_action'];

        for( var i = 0; i < conditionsLeft.length; i++){
            if ( conditionsLeft[i] === completedConditionID) {
                conditionsLeft.splice(i, 1);
                break;
            }
        }

        if(!conditionsLeft.length){
            //User just met the last condition. Update suggestion bar UI
            actionElement.css('background', 'url(/images/BGD-Stars.gif) center');
            var newHtmlStrings = generateCompletedActionHTML(window.sbData[actionID]);
            $j('#action-cta-'+ actionID).replaceWith(newHtmlStrings.cta);
            setTimeout(function () {
                actionElement.replaceWith(newHtmlStrings.action);
            }, 2000);

            //See if all the actions are completed
            var completed = 1;
            for (var key in sbData){
                if(sbData[key].hasOwnProperty('user_conditions_left_per_action') && sbData[key]['user_conditions_left_per_action'].length){
                    completed = 0;
                }
            }

            if(completed){
                $j.ajax({
                    url: '/ajax/log_suggestionbar_completions.php',
                    type: 'post',
                    data: {
                        'completed_all': completed
                    }
                })
            }
        }

        window.sbData[actionID]['user_conditions_left_per_action'] = conditionsLeft;
    }
}

//Mimics SuggestionBarAction::getSuggestedActionHtml()
function generateCompletedActionHTML(actionData){
    var actionID = actionData['action_id'];
    var borderClass = actionData['display_order'] < 3 ? 'bordered' : '';
    var actionType = actionData['type'] ? actionData['type'] : '';
    var actionIcon = actionType === 'badge' ? $j('#action-' + actionID + ' .suggested-action-icon').attr('src') : '/images/suggested_actions/icon_success.png';
    var header = actionType === 'badge' ? 'Nice work!' : actionData['accomplished_header'];
    var subheader = actionData['accomplished_subheader'] ? actionData['accomplished_subheader'] : '';
    var cta = actionData['collapse_bar_cta'] ? actionData['collapse_bar_cta'] : actionData['cta'];
    var url = actionData['url'] ? actionData['url'] : '#';
    var iconHtml = "<a href='" + url + "'><img class='suggested-action-icon' src='" + actionIcon + "'></a>";
    var headerHtml = "<div class='action-header'><a href='" + url + "'>" + header + "</a></div>";
    var subheaderHtml = subheader ? "<div class='action-subheader'>" + subheader + "</div>" : '';

    return {
        cta: '<div class="collapse-bar-cta accomplished ' + borderClass + '"><img src="/images/suggested_actions/gray-check.svg"> <a href="#" class="cta-text">' + cta + '</a></div>',
        action: "<div id='action-" + actionData['action_id'] + "' class='suggested-action accomplished " + borderClass + " " + actionType + "'>" + iconHtml + " " + headerHtml +  " " + subheaderHtml + "</div>"
    };
}

//Special logic to update Sampler Platter Suggested Action when they earn the badge without refreshing
function updateSamplerPlatter(categoryID){
    var actionID = typeof window.samplerPlatterActionID !== 'undefined' ? window.samplerPlatterActionID : 3;
    if(
        typeof window.updateSuggestionsBar === 'function' &&
        typeof window.sbData !== 'undefined' &&
        window.sbData[actionID] &&
        (typeof window.userKey !== 'undefined' || typeof window.userID !== 'undefined') &&
        (typeof window.stopwatch === 'undefined' || !window.stopwatch)
    ){
        var catConditionMap = window.sbData[actionID]['category_condition_map'];
        var conditionMet = catConditionMap[categoryID];
        var conditionsLeft = window.sbData[actionID]['user_conditions_left_per_action'];

        if(conditionsLeft.indexOf(conditionMet) < 0){
            //Already met this condition, do nothing
            return;
        }

        var newProgressValue = Object.keys(catConditionMap).length - conditionsLeft.length + 1;
        $j('.suggested-action-progress progress').attr('value', newProgressValue);

        if(conditionsLeft.length === 1){
            var lastConditionID = conditionsLeft[0];
            if(catConditionMap[categoryID] == lastConditionID){
                //User just met the last condition for sampler platter badge. Update UI
                updateSuggestionsBar(actionID, lastConditionID);
            }
        } else {
            var tooltipData = window.sbData[actionID]['tooltip_data'];

            tooltipData[conditionMet]['complete'] = 1;
            tooltipData[conditionMet]['condition_earned_date'] = (new Date()).toLocaleDateString(undefined, { year: 'numeric', month: 'short', day: 'numeric' });

            var el = $j('#action-' + actionID + ' .suggested-action-progress');
            if(el.length){
                $j(el).unbind(); //Get rid of old toolip
                setupSuggestedActionProgressTooltip($j(el), tooltipData,  $j('#suggested-action-tooltip-template'));
            }
        }
    }
}

//Special logic to update Baby Steps action when they earn the badge without refreshing
function updateBabySteps(){
    var actionID = typeof window.babyStepsActionID !== 'undefined' ? window.babyStepsActionID : 4;
    if(
        typeof window.updateSuggestionsBar === 'function' &&
        typeof window.sbData !== 'undefined' &&
        window.sbData[actionID] &&
        (typeof window.userKey !== 'undefined' || typeof window.userID !== 'undefined') &&
        (typeof window.stopwatch === 'undefined' || !window.stopwatch)
    ){
        var progressBar = $j('.suggested-action-progress progress');
        var val = progressBar.val();
        var max = progressBar.attr('max');

        val++;

        $j('.suggested-action-progress progress').attr('value', val);

        if(val == max){
            //User just met the last condition for sampler platter badge. Update UI
            updateSuggestionsBar(actionID, 2415);
        }
    }
}

function jiggleElement(jqueryEl){
    jqueryEl.addClass('wiggly-jiggly').on('webkitAnimationEnd oanimationend msAnimationEnd animationend', function(e){
        $j(this).delay(200).removeClass('wiggly-jiggly');
    });
}

function setupPromo() {
	if (!window.Sporcle || !window.Sporcle.promotions) {
		return
	}
	
	var promos = window.Sporcle.promotions || {};

	// Clear out expired keys for any promos
	var promoTimestamp;
	var dismissCount;
	var now = Math.floor(Date.now() / 1000);
	Object.keys(promos.keys).forEach(function(key) {
		if (key == 'orange') {
			dismissCount = window.localStorage.getItem(promos.keys['orange']);

			//When we used time for dismiss counts
			if (parseInt(dismissCount) > 1000000000) {
				dismissCount = 1;
				window.localStorage.setItem(promos.keys['orange'], 1);
			}
		} else {
			promoTimestamp = window.localStorage.getItem(promos.keys[key]);
			if (promoTimestamp !== null && parseInt(promoTimestamp, 10) + promos.expire < now) {
				window.localStorage.removeItem(promos.keys[key]);
			}
		}
	});

	// Current promo
	var key = promos.keys[promos.current];
	var showPromo = false;
	var dismissCount = 0;
	if (window.localStorage.getItem(key) === null) {
		showPromo = true;
	} else if (promos.current == 'orange') {
		dismissCount = parseInt(window.localStorage.getItem(key));

		//This could probably be written more concisely, but I wanted the existing rules to be easy to understand
		if (promos.ad_blocking && !promos.logged_in && dismissCount < 5) {
			showPromo = true;
		} else if (promos.ad_blocking && promos.logged_in && dismissCount < 3) {
			showPromo = true;
		} else if (!promos.ad_blocking && !promos.logged_in && dismissCount < 2) {
			showPromo = true;
		} else if (!promos.ad_blocking && promos.logged_in && dismissCount < 1) {
			showPromo = true;
		}
	}

	if (showPromo) {
		var $promo = $j('#adhesion-promo');
		$promo.css('display', 'flex').find('.close').on('click', function() {
			$promo.hide();
			if (promos.current == 'orange') {
				window.localStorage.setItem(key, dismissCount + 1);

			} else {
				window.localStorage.setItem(key, Math.floor(Date.now() / 1000).toString());
			}
		});
	}
}

function escapeNotificationDropdown(e, result) {
	const notificationsDropdownEl = $j('#notifications-dropdown');
	const notificationsBoxEl = $j('#notifications-box');

	if (notificationsDropdownEl.hasClass('visible')) {
		notificationsDropdownEl.removeClass('visible');
	} else {
		toggleNotificationDropdown(e, result.notification_count, result.new_notifications_count, result.messages_count, result.new_message_count);
	}

	$j('#notifications-box').toggleClass('active');

	toggleAriaExpanded('#notifications-box', 'aria-expanded');
}

function toggleAriaExpanded(toggleEl) {
	if ($j(toggleEl).attr('aria-expanded') === 'false') {
			$j(toggleEl).attr('aria-expanded', 'true');
	} else {
		$j(toggleEl).attr('aria-expanded', 'false');
	}
}

function tabOutOfDropdownEventListener (listenEl, callback) {
	$j(listenEl).last().on('keydown', function(e) {
		if (e.keyCode === 9 && !e.shiftKey) {
			callback(e);
		}
	});
}

function thumbKeyDownEventListener(listenEl, activeEl, callback, ...args) {
	$j(listenEl).on('keydown', e => {
		if ((e.keyCode === 27 && $j(activeEl).hasClass('active')) || 
			(e.keyCode === 9 && e.shiftKey && $j(activeEl).hasClass('active'))) {
				callback(e, ...args);
		}
	});
}

function escapeDropdownEventListener(listenEl, activeEl, callback, ...args) {
	$j(listenEl).on('keydown', function(e) {
		if (e.keyCode === 27 && $j(activeEl).hasClass('active')) {
			callback(e, ...args)
	
			$j(activeEl).focus();
		}
	});
}

function composeMessageEventListener() {
	$j('#seeAll a').last().on('keydown', function(e) {
		if (e.keyCode === 9 && !e.shiftKey) {
			escapeNotificationDropdown(e);
		} else if (e.keyCode === 13) {
			compose()
		}
	});
}
