var stop = false;
var mweb = mweb || 0;
var giveUpDelay = 7;
var gameTimer;
var startTime;
var origSecs;
var timerSecs;
var pausedTime = 0;
var pausedStartTime;
var overrideSecs = -1;
var timerCorrection;
var inProgress = false;
var didGiveUp = false;
var stopwatch = false;
var multipageMC = multipageMC || false;
var scoreAsPercentage = false;
var numRight = 0;
var currDisplayScore = 0;
var oldTime = null;

var _HTMLFocus = HTMLElement.prototype.focus;
function stubFocus() {
	if (
		(this.id === 'gameinput')
		|| (this.id === 'grid-cells')
		|| (this.id === 'chat-textarea')
		|| (this.id === 'showdownChatEntry')
		|| (this.id === 'comment_textarea')
		|| (
			(this.classList && this.classList.contains)
			&& (
				(this.classList.contains('how-to-instructions'))
				|| (this.classList.contains('usernameInput'))
			)
		)
	) {
		_HTMLFocus.apply(this, arguments);
	} else {
		var stack = new Error().stack || '';

		stack = stack
			.split('\n')
			.map(function (line) {
				return line.trim();
			})
			.filter(function(line) {
				return line;
			});

		$j.ajax({
			url  : '/ajax/focus.php',
			type : 'post',
			data : JSON.stringify({
				version : 2,
				type    : 'monkeyFocus',
				time    : Math.round((new Date()).getTime() / 1000),
				uid     : userID,
				spuid   : spuid,
				gid     : gameID,
				o       : hasOrange,
				m       : hasMembership,
				s       : stack,
				sb      : stack[stack.length - 1],
				gi      : inProgress,
				si      : showdownActive,
				this    : {
					id        : this.id,
					classList : this.classList,
					name      : this.name,
					nodeName  : this.nodeName,
					pos       : this.getBoundingClientRect()
				}
			})
		});

		_HTMLFocus.apply(this, arguments);
	}
}

$j(function () {
	oldTime = $j('#time').html().trim();
});

function selectTimerSetting(selection, isShowdown) {
	if (inProgress) {
		return;
	}
	if (typeof isShowdown === 'undefined') {
		isShowdown = false;
	}

	var settings = $j('#timeBox .timerScoreControls .dropdown li button');
	var setting;

	for (var i = 0; i < settings.length; i++) {
		setting = $j(settings[i]);

		if (setting.attr('value') == selection) {
			setting.addClass('active');
		} else {
			setting.removeClass('active');
		}
	}

	// Only do the things if the mode actually changes
	if (selection === 'timer' && stopwatch) {
		stopwatch = false;
		$j('#timeBox .timerScoreSettingsHelp').hide();
		$j('#time').html(oldTime);
		$j('#timeBox .timerScoreTitle').html('Timer');
		$j('#timeBox, #scoreBox').removeClass('timePast');
		if (isShowdown) {
			$j('#share-game-challenge').addClass('disabled');
			showCollapsedFriendScores({mode: 'showdown'});
		} else {
			$j('#share-game-challenge').removeClass('disabled');
			showCollapsedFriendScores({mode: 'highscores'});
		}
	} else if (selection === 'stopwatch' && !stopwatch) {
		stopwatch = true;
		$j('#timeBox .timerScoreSettingsHelp').show();
		$j('#time').html('00:00');
		$j('#timeBox .timerScoreTitle').html('Stopwatch');
		$j('#share-game-challenge').addClass('disabled');
		$j('#timeBox, #scoreBox').addClass('timePast');
		showCollapsedFriendScores({mode: 'stopwatch'});
	}
}

function selectScoreSetting(selection) {
	var settings = $j('#scoreBox .timerScoreControls .dropdown li button');

	var setting;

	for (var i = 0; i < settings.length; i++) {
		setting = $j(settings[i]);

		if (setting.attr('value') == selection) {
			setting.addClass('active');
		} else {
			setting.removeClass('active');
		}
	}

	if (selection == 'numeric') {
		scoreAsPercentage = false;
	} else if (selection == 'percentage') {
		scoreAsPercentage = true;
	}

	displayScore();
}

function startTimer() {
	timerSecs = stopwatch ? 0 : origSecs;
	startTime = new Date().getTime();
	gameTimer = setTimeout(redo, 1000);
}

function displayScore(numCorrect) {
	if (typeof numCorrect === 'undefined') {
		numCorrect = currDisplayScore;
	} else {
		currDisplayScore = numCorrect;
	}

	if (scoreAsPercentage) {
        var userPct = _.round((numCorrect/answers.length), 2);
		var score = _.round(100 * userPct) + '%';
	} else {
		var score = numCorrect + "/" + answers.length;

		if (mweb) {
			var score = numCorrect + " / " + answers.length;
	}
	}

	$j('.correctnum').text(numCorrect);
	$j('#scoreBox .currentScore').text(score);
}

function displayTime(totalSecs) {
	var min = Math.floor(totalSecs/60);
	var sec = totalSecs%60;
	return (min<10?"0":"")+min+":"+(sec<10?"0":"")+sec;
}

function endGame()  {
	HTMLElement.prototype.focus = _HTMLFocus;

	if (!inProgress) return;

	inProgress = false;

	clearTimeout(gameTimer);
	showMissed();
    if(!showdownActive && !mweb){
        fetchNewHistogram(updateHistogramData(numRight));
    }
	$j(window).trigger('endgame');
	$j('body').removeClass('active').addClass('over');

	callSPHooks('end');

	if(mweb){
	    var banner = $j('#promo-container');
	    if(banner.attr('data-reshow-on-end') == 1){
            banner.show();
        }
    }
}

function giveUp() {
	didGiveUp = true;
	logPlay();
	endGame();
}

function addGiveUp() {
	if (mweb) {
		$j('#giveUp').prop('disabled', false).one('click', giveUp);
	} else {
	$j('#giveUp').html("<a href='javascript:giveUp();'>Give Up</a>").show();
	}
}

function redo() {
	if (stop) {
		return;
	}

	timerSecs += stopwatch ? 1 : -1;

	if (stopwatch) {
		if (timerSecs == giveUpDelay) {
			addGiveUp();
		}
	} else {
		if ((origSecs - timerSecs) == giveUpDelay) {
			addGiveUp();
		}

		if (timerSecs == 10) {
			$j('#timeBox').addClass('timeTicking');
		}
	}

	if (guessesRemaining == 0) {
		/* Process the end of a click box or picture click game where they ran out of guesses (regardless if they got them all right) */
		logPlay();
		endGame();

		return;
	}

	if (inProgress && found.length == answers.length) {
		/* Process the end of normal game where they got them all right before the time ran out */
		logPlay();
		endGame();
		return;
	}

	$j('#time').html(displayTime(timerSecs));

	if (timerSecs == 5999) {
		// End the game if the timer ever hits 99:59. This is for stopwatch
		logPlay();
		endGame();
		return;
	}

	if (stopwatch) {
		if (timerSecs == origSecs) {
			/* They ran out of time, log a timer play but keep counting up */
			logTimerPlay();

			$j.get('/games/includes/event.php', {g:gameID, mw:mweb, sw:stopwatch?1:0, a:'av'});
		}
		timerCorrection = (new Date().getTime() - (startTime+pausedTime)) - (timerSecs*1000);
		gameTimer = setTimeout(redo, 1000-timerCorrection);
	} else {
		if (timerSecs == 0) {
			/* Process the end of any game where they ran out of time */
			logPlay();
			endGame();
			return;
		} else {
			/* Restart the timer */
			timerCorrection = (new Date().getTime() - (startTime+pausedTime)) - ((origSecs-timerSecs)*1000);
			gameTimer = setTimeout(redo, 1000-timerCorrection);
		}
	}
}

function getLogData() {
	var ls = getLogStrings();
	ls.logString = ls.logString || '';
	ls.logBonusString = ls.logBonusString || '';

	var logTime = origSecs-timerSecs;
	if (stopwatch) {
		logTime = timerSecs;
	} else if (multipageMC) {
		logTime = originalTime-timerSecs;
	}

	var logData = {
		g    : gameID,
		a    : ls.logString,
		t    : logTime,
		b    : ls.logBonusString,
		tzo  : (new Date()).getTimezoneOffset(),
		p    : typeof siteID !== 'undefined' ? siteID : 0,
		pl   : typeof playlistID !== 'undefined' ? playlistID : '',
		ho   : typeof hasOrange !== 'undefined' ? hasOrange : 0,
		hpm  : typeof hasMembership !== 'undefined' ? hasMembership : 0,
		ldtm : loadTime,
		avg_pct : typeof averageScore !== 'undefined' ? averageScore : 0,
	};

	if (isEmbed) {
		if (typeof spuid != 'undefined' && spuid) logData.spuid = spuid;
	}

	return logData;
}

function logPlay() {
	if (showdownActive) {
		return;
	}

	if (stopwatch) {
		logTimerPlay();
		logStopwatchPlay();
	} else {
		logTimerPlay();
	}

	return;
}

function logTimerPlay() {
	// This is so postLog waits for us to get a response back from log_results before attempting to do postLog stuff
	var deferredData = $j.Deferred();
	postLog = postLog.bind(null, deferredData);

	var logData = getLogData();
	logData.swm = stopwatch ? 1 : 0;
	logData.mpmc = multipageMC ? 1 : 0;
	logData.nur = typeof newUserRecommended !== 'undefined' && newUserRecommended ? 1 : 0;

	$j.get("/games/log_results.php", logData, function(data) {
		deferredData.resolve(data);
        if(data.play_is_valid && typeof userKey !== 'undefined' && !data.anonymized_play){
            if(mweb){
                getLatestPlaysToday(updateHeaderStreakMweb);
            } else {
                getLatestPlaysToday(updateHeaderStreakDsktp);
            }
        }

        if(data.play_is_valid && typeof gameID !== 'undefined'){
            var user = typeof userKey !== 'undefined' && userKey ? userKey : (typeof spuid !== 'undefined' && spuid ? spuid : false);

            if (typeof window.sbData !== 'undefined'){

                if(
                    typeof sbData[2] !== 'undefined' &&
                    typeof sbData[2]['playlist_game_ids'] !== 'undefined' &&
                    sbData[2]['playlist_game_ids'].indexOf(gameID) >= 0
                ){
                    updateSuggestionsBar(2, 1);
                }

                if(typeof gameCategoryID !== 'undefined' && typeof updateSamplerPlatter === 'function'){
                    updateSamplerPlatter(gameCategoryID);
                }

                if(
                    typeof window.sbData['update_baby_steps_on_play'] !== 'undefined' &&
                    window.sbData['update_baby_steps_on_play'] &&
                    typeof updateBabySteps === 'function'
                ){
                    updateBabySteps();
                }
            }
        }
	});

	// We only log a timer play once, so short circuit any future calls
	logTimerPlay = function(){};

	return;
}

function logStopwatchPlay() {
	var logData = getLogData();

	logData.sw = 1;
	logData.swm = stopwatch ? 1 : 0;

	$j.get("/games/log_results.php", logData, function (data) {
        if(data.play_is_valid && typeof userKey !== 'undefined' && !data.anonymized_play){
            if(mweb){
                getLatestPlaysToday(updateHeaderStreakMweb);
            } else {
                getLatestPlaysToday(updateHeaderStreakDsktp);
            }
        }
    });

	// We only log a stopwatch play once, so short circuit any future calls
	logStopwatchPlay = function(){};
}

function runFinished() {
	$j('#giveUp').empty().hide();
	$j('#pauseBox').css({visibility:'hidden'});
	$j('#replay').show();
	$j('#gameinput').prop('disabled', true);
	$j('#showmissed').prop('disabled', true);
	postLog();
}

function postLog(deferredData) {
	if (typeof deferredData === 'object') {
		// This means it is a normal play, and we are waiting for the call to log_results to finish
		$j.when(deferredData).done(function(data) {
			$j(window).trigger('postLog');

			var completedChallengeCount = 0;
			var height = 270;

			if (data.hasOwnProperty('challenge_status') && data.challenge_status.logged_in) {
				challenge = data.challenge_status;

				completedChallengeCount = challenge.record.wins + challenge.record.losses + challenge.record.ties;

				if (!challenge.rollup) {
					height += 50 * completedChallengeCount;
				}

				if (challenge.met > 0 && completedChallengeCount === 0) {
					$j('#game-message').html('<a href="/challenge/pending/">Challenge met!</a>');
					$j('#game-message-box').attr('class', 'alertNeutral').fadeIn({duration: 0.25});
				}
			}

			if (data.hasOwnProperty('league_status') && data.league_status.encoded_tournament_id) {
				$j('#game-message-box').hide();
				SporcleLib.Modal.openTriviaLeaguePostGameModal({
					tid : data.league_status.encoded_tournament_id,
					gid : gameID
				});
			} else if (completedChallengeCount > 0) {
				$j('#game-message-box').hide();
				if (mweb) {
					$j(window).trigger('postChallenge', {
						results : data.challenge_status,
						gid     : gameID
					});
				} else {
					SporcleLib.Modal.openPostChallengeModal({
						results : data.challenge_status,
						gid     : gameID
					});
				}

			}

			if (typeof mweb === 'undefined' || !mweb) {
				if (window.userID && window.numRight > 0) {
					if (!stopwatch) {
						// Update the played tag
						var userPct = 0;

						if (answers.length >= 1) {
							userPct = _.round(window.numRight/answers.length, 2);

							if (userPct === 0 && window.numRight > 0 ) {
								userPct = 0.01;
							} else if (userPct > 1) {
								userPct = 1;
							}
						}

						userPct = _.round(userPct*100, 0);

						if (typeof window.bestPercent === 'undefined' || window.bestPercent < userPct) {
	                        $j('#played-tag')
								.html('Best Score: '+window.numRight+'/'+answers.length+' ('+userPct+'%)')
								.show();
						}
					}

					// Update the friend scores
					var mode = stopwatch ? 'stopwatch' : 'highscores';
					var playTime = stopwatch ? timerSecs : origSecs-timerSecs;
					addPlayToFriendScoresCache(mode, window.numRight, playTime);
					showCollapsedFriendScores({mode: mode});
				}
			}
		});
	} else {
		// This means it is a showdown play, nothing was logged.
	}
}


function showAnswerBoxes() {
	$j('.answer').css({visibility:'visible'});
}

function startGame(secsStart)
{
	inProgress = true;

	callSPHooks('start');

	if (overrideSecs >= 0) {
		origSecs = overrideSecs;
		giveUpDelay -= (secsStart - overrideSecs);
	} else {
		origSecs = secsStart;
	}
	origSecs = (overrideSecs >=0) ? overrideSecs : secsStart;

	$j('#preHide').hide();
	$j('#preHideContent').show();

	$j('#playPadding').hide();

	$j('#answer-wrapper').show();

	if (mweb) {
		$j('#skip').show();
		var banner = $j('#promo-container');
		if(banner.is(':visible')){
            banner.attr('data-reshow-on-end', '1');
            banner.hide();
        }
    } else {
		$j('#skip').css({visibility:'visible'});
	}

	$j('#gameinput').prop('disabled',false);

	if (!showdownActive) {
		$j('#pauseBox').css({visibility:'visible'});
	}
	disableStopwatchPick();

	if (typeof gameID !== 'undefined' && !showdownActive) {
		var eventData = {
			g: gameID,
			mw: mweb,
			sw: stopwatch ? 1 : 0,
			a: 'st'
		};
		$j.get('/games/includes/event.php', eventData);
	}

	$j('body').addClass('play active');
	$j(window).trigger('startgame');

	$j('#gameinput').trigger('focus');
	HTMLElement.prototype.focus = stubFocus;

	startTimer();

	if (mweb) {
		$j('#pauseButton').click(function(e) {
			pauseGame();
		});
	}

	if (giveUpDelay <= 0) { addGiveUp(); }
}

function pauseGame()
{
	/* Seperated out to account for instances where we want to stop game play without displaying the pause screen */
	delayGame();

	if (typeof gameID != 'undefined') {
		$j.get('/games/includes/event.php', {g:gameID, mw:mweb, a:'p'});
	}

	showPause();
}

function delayGame() {
	pausedStartTime = new Date().getTime();
	stop = true;

}

// Grid quizzes for MW will automatically pause on being rotated horizontally if the view is too small. 
// We don't want those to be counted towards pauses or resumes in gamereport_mobile.php so break this
// out into two separate parts
function unPauseGame() {
	resumeGame()

	if (typeof gameID != 'undefined') {
		$j.get('/games/includes/event.php', {g:gameID, mw:mweb, a:'r'});
	}
}

function resumeGame() {
	stop = false;
	pausedTime += new Date().getTime() - pausedStartTime;

	if (stopwatch) {
		timerCorrection = (new Date().getTime() - (startTime+pausedTime)) - (timerSecs*1000);
	} else {
		timerCorrection = (new Date().getTime() - (startTime+pausedTime)) - ((origSecs-timerSecs)*1000);
	}

	gameTimer = setTimeout(redo, 1000-timerCorrection);

	if (!mweb) {
		$j('.instructions object, .instructions embed').show();
		$j('#gameinput').trigger('focus');
		$j('#pause-ad').html("");
	}
}

function showPause() {
	if (mweb) {
		var giveUpPause = false;

		//Give-up should be enabled
		if ((stopwatch && (timerSecs >= giveUpDelay)) || ((origSecs - timerSecs) >= giveUpDelay)) {
			giveUpPause = true;
		}

		$j(window).trigger('showPause', {
			time        : displayTime(timerSecs),
			quiz_length : answers.length,
			correct     : currDisplayScore,
			quiz_name   : window.gameNameDesc,
			give_up     : giveUpPause,
			show_score  : (Sporcle.gameData.isGrid ? 0 : 1)
		});
	} else {
		$j('.tynt-close-btn').trigger('click'); // does not behave well with pause screen
		$j('.instructions object, .instructions embed').hide();

		SporcleLib.Modal.openPauseModal({
			g        : gameID,
			time      : displayTime(timerSecs),
			stopwatch : stopwatch ? "&stopwatch=1" : undefined
		});
	}
}

function decodeFlag(f) {
	return (parseInt(f, 36) % 2 == 0);
}

function getAnswer(slotNum)
{
	if (slotNum >= answers.length) {
		thisSlot = hidden[slotNum-answers.length];
	} else {
		thisSlot = answers[slotNum];
	}

	// Don't split at closing tags "</"
	var garbledGator = (asta['<'] == ']' ? "\\" : "") + asta['<'];
	var slashNoGator = thisSlot.search("[^"+garbledGator+"]\/");
	slashNoGator = slashNoGator == -1 ? -1 : slashNoGator + 1;	// Position of first slash that has no "<" before it
	slash = thisSlot.search("^\/") == 0 ? 0 : slashNoGator;		// If string starts with slash, go with that, otherwise use first slash not preceded by "<"
	if (slash != -1)
	{
		thisSlot = thisSlot.slice(0, slash);
	}

	slotinfo = thisSlot;
	var e='';
	for(var i=0;i < slotinfo.length;i++){var c=slotinfo.slice(i,i+1);var d=false;for(var k in asta)if(asta[k]==c){	e+=k;d=true;}if(!d)	e+=c;}
	return e;
}

function shuffle(array) {
    var tmp, current, top = array.length;

    if(top) while(--top) {
        current = Math.floor(Math.random() * (top + 1));
        tmp = array[current];
        array[current] = array[top];
        array[top] = tmp;
    }

    return array;
}

function colorLum(hex, lum) {

	hex = String(hex).replace(/[^0-9a-f]/gi, '');
	if (hex.length < 6) {
		hex = hex[0]+hex[0]+hex[1]+hex[1]+hex[2]+hex[2];
	}
	lum = lum || 0;
	var rgb = "#", c, i;
	for (i = 0; i < 3; i++) {
		c = parseInt(hex.substr(i*2,2), 16);
		c = Math.round(Math.min(Math.max(0, c + (c * lum)), 255)).toString(16);
		rgb += ("00"+c).substr(c.length);
	}
	return rgb;
}

function getDarkerColor(color)
{
	return colorLum(color, -0.2);
}
